<?php
/*****
*	Administration class.
*****/
class ADMIN
{
// Constructor
	function ADMIN($db, $auth, $vars)
	{
		$this->db = $db;
		$this->auth = $auth;
		$this->vars = $vars;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// authorize access to administrtion functions.  If admin session variable is not TRUE (or not set), 
// display login form and exit, otherwise return true.  session->getVar returns FALSE if !isset()
	function authorize()
	{
		global $WIKINDX_ADMIN_PRIVATE;
		if(!$WIKINDX_ADMIN_PRIVATE)
			return;
                else if(isset($this->vars['username']) && isset($this->vars['password']))
			$this->logon();
		else if($this->session->getVar('admin'))
			return;
// catchAll
		else
			$this->initLogon();
// cleared to proceed.
	}
// Display the empty form for logging on
	function initLogon()
	{
		global $PHP_SELF;
		print "Enter your username and password to logon to the administrative interface:<P>";
                print <<< END_TEXT
                <form action="$PHP_SELF" method="post">
                <input type="hidden" name="action" value="admin">
                <table border="1" ALIGN="center">
                <tr>
                <td align=right>Username :</td>
                <td align=right><input type="text" name="username" value=""></td>
                </tr>
                <tr>
                <td align=right>Password :</td>
                <td align=left><input type="password" name="password" value=""></td>
                </tr>
	        <tr>
                <td colspan="2" align="right"><input type="submit" value="log on"></td>
	        </tr>
                </table>
                </form>
END_TEXT;
		$this->auth->gracefulExit(TRUE);
	}
// Initial logon to the system. Here we compare values to AUTH_ADMIN variables in config.inc.
        function logon()
        {
		if($this->authAdmin())
		{
			if(!$this->session->setVar('admin', TRUE))
				$this->gracefulExit(TRUE, "Unable to write to session.");
		}
		else
		{
			print "FAILED TO LOG ON<P><HR><P>";
			$this->initLogon();
			$this->auth->gracefulExit(TRUE);
		}
        }
// compare $AUTH_ADMIN username/password
	function authAdmin()
	{
		global $WIKINDX_ADMIN_USERNAME;
		global $WIKINDX_ADMIN_PASSWORD;
                if(($this->vars['username'] != $WIKINDX_ADMIN_USERNAME) || 
			($this->vars['password'] != $WIKINDX_ADMIN_PASSWORD))
				return FALSE;
		return TRUE;
	}
// Delete a resource.
// Step 1 asks for confirmation, step 2 deletes
	function deleteResource($step, $id)
	{
		$pString = "<DIV CLASS=\"intro\"><B>Delete Resource:</B><BR></DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
// Confirm delete
		if($step == 1)
		{
			global $PHP_SELF;
			include_once("classes/DISPLAY.php");
			$pString .= "In addition to the resource, all its notes, quotes and musings will be deleted. ";
			$pString .= "Furthermore, any of its writers, publishers or journal titles that are not 
				cross-referenced in other resources will also be deleted.<P>";
			$pString .= "<B>Please confirm you wish to delete the following resource:</B><P>";
			list($resourceID, $notes, $string) = DISPLAY::viewResourceDetails($id, TRUE);
			$pString .= $string;
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"deleteResource\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"step\" VALUE=\"2\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$id\">";
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"delete\"></DIV></FORM>";
// reset session
			$this->session->resetSession(array('deleteResource' => FALSE));
		}
// Really deleting.
// Not only delete resource but also check if the resource's publisher, journal, keywords or writers exist anymore.
//  Additionally, delete notes, musings and quotes.
//  If not, delete those too.
		else
		{
			if($this->session->getVar('deleteResource'))
				$this->auth->gracefulExit(TRUE, 'You have already deleted this resource.');
			include_once("classes/AUTHOR.php");
			$author = new AUTHOR($this->db);
			include_once("classes/JOURNAL.php");
			$journal = new JOURNAL($this->db);
			include_once("classes/PUBLISHER.php");
			$publisher = new PUBLISHER($this->db);
			include_once("classes/KEYWORD.php");
			$keyword = new KEYWORD($this->db);
			include_once("classes/NOTES.php");
			$notes = new NOTES($this->db);
			include_once("classes/QUOTES.php");
			$quotes = new QUOTES($this->db);
			include_once("classes/MUSINGS.php");
			$musings = new MUSINGS($this->db);
			include_once("classes/CONFIG.php");
			$config = new CONFIG();
			$config->writers();
// Grab resource type first
			$sql = $this->db->select('resource', 'type', "WHERE id=$id");
			$type = $this->db->fetchOne($this->db->query($sql));
// Grab old author, editor, etc. IDs
			$old = array();
			$author->existing($id, $config->writersArray, $old);
// if journal or web article, grab old journal id else grab publisher
			$oldJournalId = $oldPublisherId = $oldKeywords = '';
			if(($type == 'journal_article') || ($type == 'web_article'))
			{
				$sql = $this->db->select('resource', 'journal', "WHERE id=$id");
				$sth = $this->db->query($sql);
				$oldJournalId = $this->db->fetchOne($sth);
			}
			else
			{
				$sql = $this->db->select('resource', 'publisher', "WHERE id=$id");
				$sth = $this->db->query($sql);
				$oldPublisherId = $this->db->fetchOne($sth);
			}
// Grab old keywords
			$oldKeywords = $keyword->existing($id);
// Now delete resource
			$sql = $this->db->delete('resource', "WHERE id=$id");
			$this->db->query($sql);
			$this->db->optimize('resource');
			$sql = $this->db->update('summary', "total_resources = total_resources - 1");
			$this->db->query($sql);
// delete any note
			$notes->deleteNote($id);
// delete any quotes
			$quotes->deleteQuotes($id);
// delete any musings
			$musings->deleteMusings($id);
// delete any keywords
			$keyword->deleteKeywords($id);
// remove excess authors, editors?
			if(sizeof($old))
				$author->checkDelete($old);
// remove excess publisher?
			if($oldPublisherId)
				$publisher->checkDelete($oldPublisherId);
// remove excess journal?
			if($oldJournalId)
				$journal->checkDelete($oldJournalId);
// remove excess keywords?
			if($oldKeywords)
				$keyword->checkDelete($oldKeywords);
			$pString .= "Resource successfully deleted.";
// reset session
			$this->session->resetSession(array('deleteResource' => TRUE));
		}
		return $pString;
	}
}
?>
