<?php
/*****
*	Logging on and system authorisation class.
*	Includes methods for graceful exiting etc.
*****/
class AUTH
{
// Constructor
	function AUTH($db)
	{
		$this->db = $db;
	}
// Display the empty form for logging on
	function initLogon()
	{
		global $PHP_SELF;
		include_once("classes/SESSION.php");
		$session = new SESSION();
		print "Enter your username and password to logon to the system:<P>";
                print <<< END_TEXT
                <form action="$PHP_SELF" method="post">
                <input type="hidden" name="action" value="logon">
                <table border="1" ALIGN="center">
                <tr>
                <td align=right>Username :</td>
                <td align=right><input type="text" name="username" value=""></td>
                </tr>
                <tr>
                <td align=right>Password :</td>
                <td align=left><input type="password" name="password" value=""></td>
                </tr>
	        <tr>
                <td colspan="2" align="right"><input type="submit" value="log in"></td>
	        </tr>
                </table>
                </form>
END_TEXT;
// Give user the option to bypass 
// logging in simply to read.
		print "<P><HR><P><A HREF=\"" . $PHP_SELF . "?action=front\">Get READ-ONLY access.</A>";
		if(!$session->setVar('write', FALSE))
			$this->gracefulExit(FALSE, 'Unable to write to session.');
	}
// Graceful exiting.
// FALSE status is usually an emergency bail-out with no tidy printing to browser (usually occurs from 
// index.php or in the constructor of DISPLAY.php before all config.inc variables have been pulled in).
// If status == 2 (very rare) is an error after the main menu has been printed but before the submenu.
// else if $status == 1, requires two times </DIV> for mainFrame and main DIV classes and 
// DISPLAY footer() etc. to be printed.  This is all handled by DISPLAY::bailout()
	function gracefulExit($status, $message = '')
	{
// Bail out immediately.
		if(!$status)
		{
			if($message) print "<DIV class=\"warning\">ERROR: $message</DIV>";
			$this->db->close();
			ob_end_flush();
			die;
		}
// Simply call the DISPLAY constructor with displayType == 'bailout'.
		include_once("classes/DISPLAY.php");
		if($status == 1)
			new DISPLAY($this->db, $this, array('message' => $message), 'bailout');
		else
			new DISPLAY($this->db, $this, array('message' => $message), 'bailout2');
		$this->db->close();
		ob_end_flush();
		die;
	}
// Initial logon to the system.  This is different to the validateUser() method which 
// validates a returning user by checking for a valid SID.
// Here we compare values to AUTH_WRITE variables in config.inc.
        function logon($username, $password)
        {
		global $WIKINDX_AUTH_WRITE;
                if(!$username || !$password) $this->gracefulExit(FALSE, "Failed to logon.");
		include_once("classes/SESSION.php");
		$session = new SESSION();
		if($WIKINDX_AUTH_WRITE && $this->authWrite($username, $password))
		{
			if(!$session->setVar('write', TRUE))
				$this->gracefulExit(FALSE, "Unable to write to session.");
		}
		else
		{
			print "FAILED TO LOG ON<P><HR><P>";
			$this->initLogon();
			$this->gracefulExit(FALSE);
		}
        }
// compare $AUTH_WRITE username/password
	function authWrite($username, $password)
	{
		global $WIKINDX_AUTH_WRITE_USERNAME;
		global $WIKINDX_AUTH_WRITE_PASSWORD;
                if(($username != $WIKINDX_AUTH_WRITE_USERNAME) || ($password != $WIKINDX_AUTH_WRITE_PASSWORD))
			return FALSE;
		return TRUE;
	}
// validate a returning user by checking for a valid SID
	function validateUser()
	{
		global $HTTP_SESSION_VARS;
		if(empty($HTTP_SESSION_VARS)) return FALSE;
		return TRUE;
	}
}
?>
