<?php
/*****
*	Author class
*****/
class AUTHOR
{
// Constructor
	function AUTHOR($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		$this->authors = array();
		$this->pString = '';
	}
// Display form fields for inputting author names.
	function formFields($type, $author = 'author1')
	{
		$numAuthors = $this->session->getVar('numAuthors');
		$numEditors = $this->session->getVar('numEditors');
// if ! $numAuthors, we are editing and numAuthors has not been written to session.  Display all authors fields.
		if(!$this->session->issetVar('numAuthors'))
			$numAuthors = 6;
		if(!$numAuthors)
			return;
		include_once("classes/NAME.php");
		$name = new NAME($this->db, $type);
		if(($author == 'author1') && ($type == 'book') && $numEditors)
			$this->pString .= "<DIV CLASS=\"tr100\"><B>At least either a first author or first 
			editor is required.</B></DIV></DIV><DIV class=\"trFrame1\">";
		if(sizeof($this->authors) || $this->authors = $name->grabAll())
		{
			$this->pString .= $name->preExistFormFields($author, $this->authors);
		}
		else
		{
			if($author == 'author1')
			{
				$title = 'First Author:';
				$class = "trFrame1";
			}
			else if($author == 'author2')
			{
				$title = 'Second Author:';
				$class = "trFrame2";
			}
			else if($author == 'author3')
			{
				$title = 'Third Author:';
				$class = "trFrame1";
			}
			else if($author == 'author4')
			{
				$title = 'Fourth Author:';
				$class = "trFrame2";
			}
			else if($author == 'author5')
			{
				$title = 'Fifth Author:';
				$class = "trFrame1";
			}
			else
			{
				$title = 'Sixth Author:';
				$class = "trFrame2";
			}
			$this->pString .= "<DIV CLASS=\"tr100\"><B>$title</B></DIV>";
			$this->pString .= "</DIV><DIV class=\"$class\">";
		}
		$req = '';
		if(($author == 'author1') && ($type != 'book'))
			$req = '*';
		$this->pString .= $name->firstname($author, $req);
		$this->pString .= $name->initials($author, $req);
		$this->pString .= $name->surname($author, $req);
		if(($author == 'author1') && ($numAuthors > 1))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->formFields($type, 'author2');
		}
		else if(($author == 'author2') && ($numAuthors > 2))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->formFields($type, 'author3');
		}
		else if(($author == 'author3') && ($numAuthors > 3))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->formFields($type, 'author4');
		}
		else if(($author == 'author4') && ($numAuthors > 4))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->formFields($type, 'author5');
		}
		else if(($author == 'author5') && ($numAuthors > 5))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->formFields($type, 'author6');
		}
		else
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->pString .= $name->etAl('et_al');
			$this->pString .= "</DIV><DIV CLASS=\"clear\"><HR></DIV>";
			$this->pString .= "<DIV class=\"trFrame1\">";
		}
		return $this->pString;
	}
// write author table.
// 'author1ID' and 'author2ID' etc. are superseded by 'author1_surname' etc. if they exist.
// If 'author1_surname' doesn't exist in session, return ID from author table.
// Also used for editors, translators and revisers.
	function writeSql($author)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
// NB getVar() returns false if data is not set.
		if($this->session->issetVar($author . '_surname'))
		{
			$surname = trim($html->removeNl($this->session->getVar($author . '_surname')));
			$firstname = trim($html->removeNl($this->session->getVar($author . '_firstname')));
			$initials = $this->formatInitials(trim($html->removeNl($this->session->getVar(
				$author . '_initials'))));
			if($authorID = $this->checkExists($surname, $firstname, $initials))
				return $authorID;
			$sqlKey = 'surname';
			$string = "'" . $this->db->tidyInput($surname) . 
				"'";
			if($this->session->issetVar($author . '_initials'))
			{
				$sqlKey .= ', initials';
				$string .= ", '" . 
					$this->formatInitials($this->db->tidyInput($initials)) . "'";
			}
			if($this->session->issetVar($author . '_firstname'))
			{
				$sqlKey .= ', firstname';
				$string .= ", '" . $this->db->tidyInput($firstname) . "'";
			}
			$sql = $this->db->insert('writer', "$sqlKey", "$string");
			if(!$this->db->query($sql))
				return FALSE;
			return $this->db->lastAutoID();
		}
		else if($this->session->getVar($author . 'ID'))
		{
			return $this->session->getVar($author . 'ID');
		}
		else
		{
// set to NULL if no input.
			return 'NULL';
		}
	}
// Build sql arrays for adding to resource table
	function sqlArrays(&$keys, &$values, &$nulls, $bookType)
	{
		$list = array('author1', 'author2', 'author3', 'author4', 'author5', 'author6');
		$this->sqlArraysGeneric($keys, $values, $nulls, $list);
		if(($bookType == 'book') || ($bookType == 'book_article'))
		{
			$list = array('editor1', 'editor2', 'editor3', 'editor4', 'editor5', 'editor6');
			$this->sqlArraysGeneric($keys, $values, $nulls, $list);
			$list = array('translator1', 'translator2', 'translator3');
			$this->sqlArraysGeneric($keys, $values, $nulls, $list);
			$list = array('reviser1', 'reviser2', 'reviser3');
			$this->sqlArraysGeneric($keys, $values, $nulls, $list);
		}
		return TRUE;
	}
// generic function to build sql arrays for adding to resource table
	function sqlArraysGeneric(&$keys, &$values, &$nulls, $list)
	{
		$array = array();
		foreach($list as $element)
		{
			if(!$var = $this->writeSql($element))
				return FALSE;
			if($var != 'NULL')
				$array[] = $var;
		}
		foreach($array as $key => $value)
		{
			$keys[] = array_shift($list);
			$values[] = $value;
		}
		foreach($list as $key)
			if(!array_key_exists($key, $keys))
				$nulls[] = "$key=NULL";
	}
// Does this author already exist in the database?
	function checkExists($surname, $firstname, $initials)
	{
		$sql = $this->db->select('writer', '*');
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			if((strtolower($surname) == strtolower($row['surname'])) && 
				(strtolower($firstname) == strtolower($row['firstname'])) && 
				(strtolower($initials) == strtolower($row['initials'])))
					return $row['id'];
		}
		return FALSE;
	}
// Format initials prior to storing in database
// Initials are stored uppercase, unpunctuated and space-delimited.
// In the final result, they can only consist of a-Z and space characters
	function formatInitials($raw)
	{
		return implode(' ', preg_split('//', 
			strtoupper(preg_replace('/\W+/', '', $raw)), -1, PREG_SPLIT_NO_EMPTY));
	}
// When editing a resource, the author's name may be edited.  If the original author 
// no longer has attached resources (author1, author2, author3, editor1, editor2, editor3, translator or reviser 
// columns), remove from author table.
//  Also used for admin deletes of a resource.
	function checkDelete($ids)
	{
		$deleted = FALSE;
		$this->ids = array();
		foreach($ids as $id)
			$this->findIds($id);
// if some IDs not found, delete from writer table
		foreach($this->ids as $id)
		{
			$sql = $this->db->delete('writer', "WHERE id=" . $id);
			$this->db->query($sql);
			$deleted = TRUE;
		}
		if($deleted)
			$this->db->optimize('writer');
	}
// find IDs in resource tables
	function findIds($id)
	{
		$condition = $this->makeCheckDeleteStrings($id);
		$sql = $this->db->select('resource', 'id', $condition);
		$sth = $this->db->query($sql);
		if($this->db->numRows($sth))
// If name ID found, go immediately to next ID, else stick this ID into array to be deleted
			return;
		array_push($this->ids, $id);
	}
// make select strings for checkDelete
	function makeCheckDeleteStrings($id)
	{
		$condition = "WHERE author1=" . $id . " OR author2=" . $id . " OR author3=" . $id . 
			" OR author4=" . $id . " OR author5=" . $id . " OR author6=" . $id . 
			" OR editor1=" . $id . " OR editor2=" . $id . " OR editor3=" . $id . 
			" OR editor4=" . $id . " OR editor5=" . $id . " OR editor6=" . $id . 
			" OR translator1=" . $id . " OR translator2=" . $id . " OR translator3=" . $id . 
			" OR reviser1=" . $id . " OR reviser2=" . $id . " OR reviser3=" . $id;
		return $condition;
	}
// get existing authors
	function existing($resourceID, $writersArray, &$old)
	{
		$string = implode(", ", $writersArray);
		$sql = $this->db->select('resource', $string, "WHERE id=$resourceID");
		$sth = $this->db->query($sql);
		$row = $this->db->fetchAssoc($sth);
		$return = array();
		foreach($row as $key => $value)
			if($row[$key])
				$old[$key] = $value;
	}
}
?>
