<?php
/*****
*
* Generic RDBMS handling class
*
*****/
class DB
{
// Constructor
	function DB()
	{
		global $WIKINDX_DB_HOST;
		global $WIKINDX_DB_USER;
		global $WIKINDX_DB_PASSWORD;
		global $WIKINDX_DB;
		global $WIKINDX_DB_TYPE;
		if(!isset($WIKINDX_DB_HOST) || !isset($WIKINDX_DB_USER) || !isset($WIKINDX_DB_PASSWORD) 
			|| !isset($WIKINDX_DB) || !isset($WIKINDX_DB_TYPE))
			die("Missing Configuration Parameter.");
		$this->host = $WIKINDX_DB_HOST;
		$this->user = $WIKINDX_DB_USER;
		$this->pword = $WIKINDX_DB_PASSWORD;
		$this->dbase = $WIKINDX_DB;
		$this->dbaseType = $WIKINDX_DB_TYPE;
		$this->handle = NULL;
		if(!$this->open()) die($this->error());
	}
// Connect to the RDBMS server and select the database
	function open()
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			if(!$this->handle = mysql_pconnect($this->host, $this->user, $this->pword)) return false;
			if(!mysql_select_db($this->dbase, $this->handle)) return false;
			break;
		case 'postgres':
			$this->connString = 'host=' . $this->host;
			$this->connString .= ' user=' . $this->user;
			$this->connString .= ' password=' . $this->pword;
			$this->connString .= ' dbname=' . $this->dbase;
			if(!$this->handle = pg_pconnect($this->connString)) return false;
			break;
		case 'mssql':
			if(!$this->handle = mssql_pconnect($this->host, $this->user, $this->pword)) return false;
			if(!mssql_select_db($this->dbase, $this->handle)) return false;
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
		return true;
	}
// Close the rdbms server connection
	function close()
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			$close = 'mysql_close';
			break;
		case 'postgres':
			$close = 'pg_close';
			break;
		case 'mssql':
			$close = 'mssql_close';
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
		return $close($this->handle);
	}
// Handle queries
        function query($querystr)
	{
		$result = false;
		switch($this->dbaseType)
		{
		case 'mysql':
                        $result = mysql_query($querystr, $this->handle);
			break;
		case 'postgres':
			$result = pg_exec($this->handle, $querystr);
			break;
		case 'mssql':
			$result = mssql_query($querystr, $this->handle);
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
                }
// increment no. queries
		global $WIKINDX_DB_QUERIES;
		$WIKINDX_DB_QUERIES++;
		return $result;
	}
// Return the number of rows in the query result
	function numRows($result)
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return mysql_num_rows($result);
			break;
		case 'postgres':
			return pg_num_rows($result, 0);
			break;
		case 'mssql':
			return mssql_num_rows($result);
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// Return a single value from a db row
	function fetchOne($result)
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			$row = mysql_fetch_row($result);
			return $row[0];
			break;
		case 'postgres':
			$row = pg_fetch_row($result, 0);
			return $row[0];
			break;
		case 'mssql':
			$row = mssql_fetch_row($result);
			return $row[0];
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// Return an associative array from the database
	function fetchAssoc($result)
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return(mysql_fetch_assoc($result));
			break;
		case 'postgres':
			return(pg_fetch_array($result, 0, PGSQL_ASSOC));
			break;
		case 'mssql':
			return(mssql_fetch_assoc($result));
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// format a string for SELECT statements
	function select($table, $string, $conditions = '')
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return "SELECT $string FROM $table $conditions";
			break;
		case 'postgres':
			return "SELECT $string FROM $table $conditions";
			break;
		case 'mssql':
			return "SELECT $string FROM $table $conditions";
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// format a string for INSERT statements
	function insert($table, $fields, $values, $conditions = '')
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return "INSERT INTO $table ($fields) VALUES($values) $conditions";
			break;
		case 'postgres':
			return "INSERT INTO $table ($fields) VALUES($values) $conditions";
			break;
		case 'mssql':
			return "INSERT INTO $table ($fields) VALUES($values) $conditions";
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// format a string for UPDATE statements
	function update($table, $string, $conditions = '')
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return "UPDATE $table SET $string $conditions";
			break;
		case 'postgres':
			return "UPDATE $table SET $string $conditions";
			break;
		case 'mssql':
			return "UPDATE $table SET $string $conditions";
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// format a string for DELETE statements - LOW PRIORITY
	function deleteLoPriority($table, $conditions = '')
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return "DELETE LOW PRIORITY FROM $table $conditions";
			break;
		case 'postgres':
			return "DELETE LOW PRIORITY FROM $table $conditions";
			break;
		case 'mssql':
			return "DELETE LOW PRIORITY FROM $table $conditions";
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// format a string for DELETE statements
	function delete($table, $conditions = '')
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return "DELETE FROM $table $conditions";
			break;
		case 'postgres':
			return "DELETE FROM $table $conditions";
			break;
		case 'mssql':
			return "DELETE FROM $table $conditions";
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// optimize a table
	function optimize($table)
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			$sql = "OPTIMIZE TABLE $table";
			break;
		case 'postgres':
			$sql = "OPTIMIZE TABLE $table";
			break;
		case 'mssql':
			$sql = "OPTIMIZE TABLE $table";
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
// Not fatal if query fails.
		$this->query($sql);
	}
// tidy up input by trimming and escaping
	function tidyInput($string)
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return(mysql_escape_string($this->stripHtml(htmlspecialchars((trim($string))))));
			break;
// is there no equivalent to mysql_escape_string for postgres and mssql?
		case 'postgres':
			return(addslashes($this->stripHtml(trim($string))));
			break;
		case 'mssql':
			return(addslashes($this->stripHtml(trim($string))));
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// return last autoincrement ID for this DB resource
	function lastAutoID()
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return mysql_insert_id($this->handle);
			break;
// Not sure what equivalent is for other RDBMS - may have to hack it by directly reading last inserted ID 
/*		case 'postgres':
			$row = pg_fetch_row($result, 0);
			return $row[0];
			break;
		case 'mssql':
			$row = mssql_fetch_row($result);
			return $row[0];
			break;
*/		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// Handle errors
	function error()
	{
		switch($this->dbaseType)
		{
		case 'mysql':
			return mysql_error();
			break;
		case 'postgres':
			return pg_errormessage();
			break;
		case 'mssql':
// not sure about this one....does it return an error message?
			return mssql_get_last_message();
			break;
		default:
			print "No RDBMS type selected in config.inc<BR>";
			die;
		}
	}
// Strip HTML characters of type '<...>' from database input
	function stripHtml($string)
	{
		return preg_replace("/\<.*?\>/", " ", $string);
	}
}
?>
