<?php
/*****
* HTML coding class
*****/
class HTML
{
// Constructor
	function HTML()
	{
	}
// create select boxes form HTML forms
// requires $name, $array and optional $size.
// No default selection.
// OPTION VALUE is set so expects assoc. array where key holds this value
	function selectBoxValue($name, $array, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\">";
		foreach($array as $key => $value)
		{
			$pString .= "<OPTION VALUE=\"$key\">$value</OPTION>";
		}
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes form HTML forms
// requires $name, $array and optional $size.
// First entry is default selection.
// OPTION VALUE is set so expects assoc. array where key holds this value
	function selectFBoxValue($name, $array, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\">";
		$pString .= "<OPTION VALUE=\"" . key($array) . "\" SELECTED>" .current($array) . "</OPTION>";
		$doneFirst = FALSE;
		foreach($array as $key => $value)
		{
			if(!$doneFirst)
			{
				$doneFirst = TRUE;
				continue;
			}
			$pString .= "<OPTION VALUE=\"$key\">$value</OPTION>";
		}
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes form HTML forms
// requires $name, $array and optional $size.
// First entry is default selection.
// OPTION VALUE is set so expects assoc. array where key holds this value.
// MULTIPLE values may be selected
	function selectFBoxValueMultiple($name, $array, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\" MULTIPLE>";
		$pString .= "<OPTION VALUE=\"" . key($array) . "\" SELECTED>" . current($array) . "</OPTION>";
		$doneFirst = FALSE;
		foreach($array as $key => $value)
		{
			if(!$doneFirst)
			{
				$doneFirst = TRUE;
				continue;
			}
			$pString .= "<OPTION VALUE=\"$key\">$value</OPTION>";
		}
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes form HTML forms
// requires $name, $array, selected values (array of) and optional $size.
// OPTION VALUE is set so expects assoc. array where key holds this value.
// MULTIPLE values may be selected
	function selectedBoxValueMultiple($name, $array, $values, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\" MULTIPLE>";
		foreach($array as $key => $value)
		{
			$match = FALSE;
			foreach($values AS $select)
			{
				if($key == $select)
				{
					$pString .= "<OPTION VALUE=\"" . $key . 
						"\" SELECTED>" . $value . "</OPTION>";
					$match = TRUE;
					break;
				}
			}
			if(!$match)
				$pString .= "<OPTION VALUE=\"$key\">$value</OPTION>";
		}
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes form HTML forms
// requires $name, $array and optional $size.
// $select is default selection.
// OPTION VALUE is set so expects assoc. array where key holds this value
	function selectedBoxValue($name, $array, $select, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\">";
		foreach($array as $key => $value)
		{
			($key == $select) ?
				$pString .= "<OPTION VALUE=\"$key\" SELECTED>$value</OPTION>" :
				$pString .= "<OPTION VALUE=\"$key\">$value</OPTION>";
		}
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes form HTML forms
// requires $name, $array and optional $size.
// No default selection.
	function selectBox($name, $array, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\">";
		foreach($array as $value)
			$pString .= "<OPTION>$value</OPTION>";
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes for HTML forms
// requires $name, $array and optional $size.
// First OPTION is always SELECTED
	function selectFBox($name, $array, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\">";
		$pString .= "<OPTION SELECTED>" . array_shift($array) . "</OPTION>";
		foreach($array as $value)
			$pString .= "<OPTION>$value</OPTION>";
		$pString .= "</SELECT>";
		return $pString;
	}
// create select boxes for HTML forms
// requires $name, $array, selected value and optional $size.
// 'selected value' is set SELECTED
	function selectedBox($name, $array, $select, $size = 3)
	{
		$pString = "<SELECT NAME=\"$name\" SIZE=\"$size\">";
		foreach($array as $value)
		{
			($value == $select) ?
				$pString .= "<OPTION SELECTED>$value</OPTION>" :
				$pString .= "<OPTION>$value</OPTION>";
		}
		$pString .= "</SELECT>";
		return $pString;
	}
// replace wikindx code for URLs with HTML code
	function urlToHtml($string)
	{
        	return preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/i",
			"<A HREF=\"$1\" TARGET=\"_blank\">$2</A>", $string);
	}
// replace newlines and carriage returns with appropriate HTML code.
// first multiples then singles.
	function nlToHtml($string)
	{
		$string = preg_replace("/(\015?\012){2,}/", "<P>", $string);
		return preg_replace("/\n/", "<BR>", $string);
	}
// remove all newlines.  For cases when user cut 'n' pastes multiple lines into single-line text box
	function removeNl($string)
	{
		$string = preg_replace("/(\015?\012){2,}/", " ", $string);
		return preg_replace("/\r|\n/", " ", $string);
	}
}
?>
