<?php
/*****
*	Keywords class
*****/
class KEYWORD
{
// Constructor
	function KEYWORD($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// Display form fields for inputting keywords.
	function formFields()
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		$pString = "<DIV class=\"trFrame2\">";
		$pString .= "<DIV CLASS=\"tr100\">";
		$pString .= "<B>Keywords:</B><BR>";
		$pString .= "You can select keywords relating to the resource from the list and/or enter them 
			as a <B>comma-separated</B> list in the textbox below. To select more than one keyword, 
			hold down [SHIFT] or [CTRL] on your keyboard.</DIV></DIV>";
		$pString .= "<DIV class=\"trFrame2\">";
		$pString .= "<DIV CLASS=\"tr1\">";
		if($sth = $this->grabAll())
		{
			while($result = $this->db->fetchAssoc($sth))
			{
				$assoc[$result['id']] = $result['keyword'];
			}
			$newArray = array();
			$newArray[0] = 'None';
			foreach($assoc as $key => $value)
				$newArray[$key] = $value;
			$pString .= $html->selectFBoxValueMultiple('selectKeyword[]', $newArray, $size = 10);
		}
		else
		{
			$pString .= "No current keywords";
		}
		$pString .= "</DIV><DIV CLASS=\"tr60\"><B>New Keyword(s):</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"boxKeyword\" SIZE=\"40\" MAXLENGTH=\"255\"></BR>";
		$pString .= "<DIV class=\"hint\">Comma-separated list</DIV></DIV></DIV>";
		return $pString;
	}
// Display form fields for inputting keywords (EDIT a Resource).
	function formFieldsEdit($id)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		global $PHP_SELF;
// get keywords attached to this resource
		$sql = $this->db->select('resource_keywords', 'keywords', "WHERE id=$id");
		$sth = $this->db->query($sql);
		$keywords = explode(',', $this->db->fetchOne($sth));
		$pString = "<DIV class=\"trFrame2\">";
		$pString .= "<DIV CLASS=\"tr100\">";
		$pString .= "<B>Keywords:</B><BR>";
		$pString .= "You can select keywords relating to the resource from the list and/or enter them 
			as a <B>comma-separated</B> list in the textbox below. To select more than one keyword, 
			hold down [SHIFT] or [CTRL] on your keyboard.</DIV></DIV>";
		$pString .= "<DIV class=\"trFrame2\">";
		$pString .= "<DIV CLASS=\"tr1\">";
		if($sth = $this->grabAll())
		{
			while($result = $this->db->fetchAssoc($sth))
			{
				$assoc[$result['id']] = $result['keyword'];
			}
			$newArray = array();
			$newArray[0] = 'None';
			foreach($assoc as $key => $value)
				$newArray[$key] = $value;
			$pString .= $html->selectedBoxValueMultiple('selectKeyword[]', $newArray, $keywords, $size = 10);
		}
		else
		{
			$pString .= "No current keywords";
		}
		$pString .= "</DIV><DIV CLASS=\"tr60\"><B>New Keyword(s):</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"boxKeyword\" SIZE=\"40\" MAXLENGTH=\"255\"></BR>";
		$pString .= "<DIV class=\"hint\">Comma-separated list</DIV></DIV></DIV>";
		return $pString;
	}
// write tables.
// selectKeyword contains comma-separated list of IDs already in the keywords table (if '0' exists, remove it).
// boxKeyword contains comma-separated list of new keywords (lowercase and insert these into the keywords table).
// create new comma-separated list of IDs of all keywords relating to this resource and write this to the 
// resource_keywords table
	function writeSql($resourceID, $edit = FALSE)
	{
		$finalIDs = array();
// NB getVar() returns false if data is not set.
		if($select = $this->session->getVar('selectKeyword'))
		{
// find and delete '0' ('None') key if exists
			foreach(explode(',', $select) as $key)
			{
				if(!$key)
					continue;
				array_push($finalIDs, $key);
			}
		}
		if($box = $this->session->getVar('boxKeyword'))
		{
			$box = explode(',', $box);
			$boxArray = array();
			foreach($box as $value)
				array_push($boxArray, trim(strtolower($value)));
// first, check for and discard any duplicate entries.
			$sql = $this->db->select('keywords', 'keyword');
			$sth = $this->db->query($sql);
			$stored = array();
			while($result = $this->db->fetchAssoc($sth))
			{
				array_push($stored, strtolower($result['keyword']));
			}
			$indices = array_diff($boxArray, $stored);
// Second, insert new entries into keywords table and add IDs to $finalIDs array
			foreach($indices as $value)
			{
				$string = "'" . $this->db->tidyInput(ucwords(strtolower($value))) . "'";
				$sql = $this->db->insert('keywords', 'keyword', "$string");
				if(!$this->db->query($sql))
					return FALSE;
				array_push($finalIDs, $this->db->lastAutoID());
			}
		}
// finally, insert $finalIDs as comma-separated list into resource_keywords table
		if(sizeof($finalIDs))
		{
			if($edit)
			{
				$string = "keywords='" . implode(',', $finalIDs) . "'";
				$sql = $this->db->update('resource_keywords', $string, "WHERE id=$resourceID");
			}
			else
			{
				$string = "'$resourceID','" . implode(',', $finalIDs) . "'";
				$sql = $this->db->insert('resource_keywords', 'id,keywords', "$string");
			}
			if(!$this->db->query($sql))
				return FALSE;
		}
		else
		{
			if($edit)
			{
				$sql = $this->db->update('resource_keywords', "keywords=NULL", "WHERE id=$resourceID");
			}
			else
			{
				$string = "'$resourceID'";
				$sql = $this->db->insert('resource_keywords', 'id', "$string");
			}
			if(!$this->db->query($sql))
				return FALSE;
		}
		return TRUE;
	}
// grab all current keywords
	function grabAll()
	{
		$sql = $this->db->select('keywords', '*', 'ORDER BY keyword');
		$sth = $this->db->query($sql);
		if($this->db->numRows($sth))
		{
			return $sth;
		}
		else
		{
			return FALSE;
		}
	}
//  When deleting a resource, remove any left over keywords.  $keywords is comma-separated string.
	function checkDelete($keywords)
	{
		$deleted = FALSE;
		$this->ids = array();
		$ids = explode(',', $keywords);
		$this->findIds($ids);
// if some IDs not found, delete from keywords table
		$condition = "WHERE ";
		foreach($this->ids as $id)
		{
			$conditionArray[] = "id=$id";
			$deleted = TRUE;
		}
		if($deleted)
		{
			$condition .= implode(' OR ', $conditionArray);
			$sql = $this->db->delete('keywords', "WHERE id=" . $id);
			$this->db->query($sql);
			$this->db->optimize('keywords');
		}
	}
// find IDs in resource_keywords table
	function findIds($ids)
	{
		foreach($ids as $id)
			$conditionArray[] = "FIND_IN_SET($id, keywords)";
		$condition = "WHERE " . implode(' OR ', $conditionArray);
		$sql = $this->db->select('resource_keywords', 'id', $condition);
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
			$this->ids[] = $row['id'];
	}
// get existing keywords (returns comma-separated list of keyword ids
	function existing($resourceID)
	{
		$sql = $this->db->select('resource_keywords', 'keywords', "WHERE id=$resourceID");
		return $this->db->fetchOne($this->db->query($sql));
	}
// delete keywords for this resource
	function deleteKeywords($id)
	{
		$sql = $this->db->delete('resource_keywords', "WHERE id=" . $id);
		$this->db->query($sql);
		$this->db->optimize('resource_keywords');
	}
}
?>
