<?php
/*****
* Manifest class.  checks and validates all browser input
*****/
class MANIFEST
{
// Constructor
	function MANIFEST($resource, $db, $auth, $vars)
	{
		$this->resource = $resource;
		$this->db = $db;
		$this->auth = $auth;
		$this->vars = $vars;
		include_once("classes/CONFIG.php");
		$this->config = new CONFIG();
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// for 'book' a minimum of either an author or editor must be supplied - others must have author.
//  If author supplied, surname is required and may have initials and/or firstname.
	function author($type)
	{
		if(!$this->session->issetVar('author1_surname') && !$this->session->getVar('author1ID'))
		{
			if(($type == 'book') && 
				($this->session->issetVar('editor1_surname') || $this->session->getVar('editor1ID')))
					return TRUE;
			else
			{
				print "<DIV class=\"warning\">";
				print "ERROR: You must have at least a first author or, in the case of a book, a
					first editor.";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				return FALSE;
			}
		}
/* Checking that a surname comes with at least initials or firstname has been commented out.
c.f. Herodotus.
		$array = array('author1', 'author2', 'author3');
		foreach($array as $author)
		{
			if(($this->session->issetVar($author . '_firstname') ||
				$this->session->issetVar($author . '_initials')) &&
				!$this->session->issetVar($author . '_surname'))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Author's surname missing.";
				print "</DIV><P>&nbsp;</P>";
				return FALSE;
			}
			else if($this->session->issetVar($author . '_surname') &&
				(!$this->session->issetVar($author . '_initials') &&
				!$this->session->issetVar($author . '_firstname')))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Author's firstname or initials missing.";
				print "</DIV><P>&nbsp;</P>";
				return FALSE;
			}
		}
*/		
		return TRUE;
	}
// surname is required and may have initials and/or firstname.  Also handles translator & reviser.
	function editor()
	{
// Checking that a surname comes with at least initials or firstname has been bypassed. c.f. Herodotus.
		$array = array('editor1', 'editor2', 'editor3');
		foreach($array as $editor)
		{
			if(($this->session->issetVar($editor . '_firstname') ||
				$this->session->issetVar($editor . '_initials')) &&
				!$this->session->issetVar($editor . '_surname'))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Editor's surname missing.";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				return FALSE;
			}
/*			else if($this->session->issetVar($editor . '_surname') &&
				(!$this->session->issetVar($editor . '_initials') ||
				!$this->session->issetVar($editor . '_firstname')))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Editor's firstname or initials missing.";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				return FALSE;
			}
*/		}
		$array = array('translator', 'reviser');
		foreach($array as $editor)
		{
			if(($this->session->issetVar($editor . '_firstname') ||
				$this->session->issetVar($editor . '_initials')) &&
				!$this->session->issetVar($editor . '_surname'))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Translator or reviser's surname missing.";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				return FALSE;
			}
/*			else if($this->session->issetVar($editor . '_surname') &&
				(!$this->session->issetVar($editor . '_initials') &&
				!$this->session->issetVar($editor . '_firstname')))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Translator or reviser's firstname or initials missing.";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				return FALSE;
			}
*/		}
		return TRUE;
	}
// check page format.  At least page_start is required (except for web_articles).
	function page($edit = FALSE)
	{
		if(!$this->session->issetVar('page_start'))
		{
// if page_end is given but no page_start, assume page_start is meant
			if($this->session->issetVar('page_end'))
			{
				$this->session->setVar('page_start', $this->session->getVar('page_end'));
				$this->session->delVar('page_end');
				return TRUE;
			}
			print "<DIV class=\"warning\">";
			print "ERROR: Missing page start.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if($this->session->issetVar('page_start') && !is_numeric($this->session->getVar('page_start')))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Page start must be a valid number.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if($this->session->issetVar('page_end') && !is_numeric($this->session->getVar('page_end')))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Page end must be a valid number.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if($this->session->issetVar('page_start') && $this->session->issetVar('page_end'))
		{
			if($this->session->getVar('page_end') < $this->session->getVar('page_start'))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Page end cannot be less than page start.";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				if($edit)
					return FALSE;
				print $this->resource->displayForm2(FALSE);
				$this->auth->gracefulExit(TRUE);
			}
		}
		return TRUE;
	}
// check year format
	function year($year, $edit = FALSE)
	{
		if(!$this->session->issetVar($year))
			return TRUE;
		if(!is_numeric($this->session->getVar($year)) || 
			(strlen($this->session->getVar($year)) != 4))
		{
			if($year == 'volume_year')
				$string = "Volume publication year";
			else if($year == 'reprint_year')
				$string = "Year of reprinting";
			else if($year == 'year')
				$string = "Year of publication";
			print "<DIV class=\"warning\">";
			print "ERROR: $string must be a valid 4-character year such as 1952 or 2003.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// check web address is of correct format
	function webAddress($edit = FALSE)
	{
		if(!$this->vars['web_address'] || (trim($this->vars['web_address']) == 'http://'))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Missing web address.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if(!eregi("^http://", trim($this->vars['web_address'])))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Invalid URI syntax. The web address must begin with 'http://'";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// check the date string format == YYYY-MM-DD
	function dateAccess($edit = FALSE)
	{
		if(!$this->vars['date_accessed'])
			return TRUE;
		$date = trim($this->vars['date_accessed']);
		$array = explode("-", $date);
		if((sizeof($array) != 3) || 
			(strlen($array[0]) != 4) || (strlen($array[1]) != 2) || (strlen($array[2]) != 2) ||
			!is_numeric($array[0]) || !is_numeric($array[1]) || !is_numeric($array[2]))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Invalid date accessed format (YYYY-MM-DD).";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// check title of that type does not already exist.
	function title()
	{
		$array = array('type', 'title');
		foreach($array as $key)
		{
			if(!isset($this->vars[$key]) || !trim($this->vars[$key]))
			{
				print "<DIV class=\"warning\">";
				print "ERROR: Missing parameter: $key";
				print "</DIV><DIV CLASS=\"clear\"></DIV>";
				print $this->resource->displayForm1();
				$this->auth->gracefulExit(TRUE);
			}
		}
		$type = $this->vars['type'];
		$title = trim($this->vars['title']);
		$this->config->commonSql('all');
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id 
			WHERE type='$type' AND title='$title' ORDER BY author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $this->config->condition);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
			return TRUE;
// else match(es) found
		include_once("classes/DISPLAY.php");
		print "<DIV class=\"warning\">";
		print "wikindx has found at least one resource of that type with a matching title.";
		print "</DIV><DIV CLASS=\"clear\"></DIV>";
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
			print DISPLAY::displayResource($row, $index, $row['type']);
			++$index;
		}
		print $this->session->previousLink();
		$this->auth->gracefulExit(TRUE);
	}
// Check we have a valid no. of authors or editors when inputting a new resource.
	function writers($type)
	{
// If type is 'book', must have at least one author OR one editor.  all other types require at least one author.
		if($type == 'book')
		{
			if((isset($this->vars['numAuthors']) && $this->vars['numAuthors']) || 
				(isset($this->vars['numEditors']) && $this->vars['numEditors']))
					return TRUE;
		}
		else if(isset($this->vars['numAuthors']) && $this->vars['numAuthors'])
			return TRUE;
		print "<DIV class=\"warning\">";
		print "ERROR: Incorrect number of writers.";
		print "</DIV><DIV CLASS=\"clear\"></DIV>";
		print $this->resource->displayForm1();
		$this->auth->gracefulExit(TRUE);
	}
// check title of that type does not already exist beyond the resource we are editing
	function checkTitleEdit($type, $id)
	{
		if(!isset($this->vars['title']) || !trim($this->vars['title']))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Missing parameter: title";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			return FALSE;
		}
		$title = trim($this->vars['title']);
		$this->config->commonSql('all');
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id 
			WHERE type='$type' AND title='$title' 
			AND resource.id != $id ORDER BY author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $this->config->condition);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
			return TRUE;
// else match(es) found
		include_once("classes/DISPLAY.php");
		print "<DIV class=\"warning\">";
		print "wikindx has found at least one resource of that type with a matching title.";
		print "</DIV><DIV CLASS=\"clear\"></DIV>";
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
			print DISPLAY::displayResource($row, $index, $row['type']);
			++$index;
		}
		print $this->session->previousLink();
		$this->auth->gracefulExit(TRUE);
	}
// if publisher details input must have both name and location
	function publisher($edit = FALSE)
	{
		if(($this->session->issetVar('publisher_name') && !$this->session->issetVar('publisher_location')) || 
			(!$this->session->issetVar('publisher_name') && $this->session->issetVar('publisher_location')))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Publisher name or publisher location missing";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			$this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// check for journal_title or book_title for journal and book articles
	function title2($title, $edit = FALSE)
	{
		$id = '';
		if($title == 'journal_title')
			$id = 'journalID';
		else if($title == 'book_title')
			$id = 'bookID';
		if(!$this->session->issetVar($title) && !$this->session->getVar($id))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Missing $title.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			$this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// while you can have a series_title without a series_number, you can't have vice-versa
	function series($edit = FALSE)
	{
		if(!$this->session->issetVar('series_title') && $this->session->issetVar('series_number'))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Series title missing";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// prompt if only one or two of volume details, volume_number or volume_year.
// Volume_number cannot be greater than volumes
	function volume($edit = FALSE)
	{
		$count = 0;
		if($this->session->issetVar('volumes'))
			$count++;
		if($this->session->issetVar('volume_number'))
			$count++;
		if($this->session->issetVar('volume_year'))
			$count++;
		if(($count != 0) && ($count != 3))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Missing volume information.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if($this->session->getVar('volume_number') > $this->session->getVar('volumes'))
		{
			print "<DIV class=\"warning\">";
			print "ERROR: Volume number is greater than the number of volumes.";
			print "</DIV><DIV CLASS=\"clear\"></DIV>";
			if($edit)
				return FALSE;
			print $this->resource->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		return TRUE;
	}
// When adding a quote to an article that has page numbers, ensure the quote page number agrees with those page numbers.
// Return array of RESULT (TRUE/FALSE) and, if !result, available page range in form for printing to browser.
	function quotePages($resourceID, $page)
	{
// find name of correct table first
		$sql = $this->db->select('resource', 'type, page_start, page_end', "WHERE id=$resourceID");
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
			$this->auth->gracefulExit(TRUE, "Unable to edit quote.");
		$row = $this->db->fetchAssoc($sth);
// if $type == 'book', return TRUE (no page ranges)
		if($row['type'] == 'book')
			return array(TRUE, TRUE);
		if($row['page_start'])
		{
// In case of only page_start given (i.e. 'article' on just one page)
			if(!$row['page_end'] && ($row['page_start'] != $page))
				return array(FALSE, "p." . $row['page_start']);
			else if($row['page_end'] && 
				(($page < $row['page_start'] || $page > $row['page_end'])))
					return array(FALSE, "pp." . $row['page_start'] . '-' . $row['page_end']);
		}
// $page meets all requirements.
		return array(TRUE, FALSE);
	}
// check input required when adding or editing a quote
	function quote($quoteObject, $edit = FALSE)
	{
		if($edit)
		{
			if(!isset($this->vars["id"]))
				$this->auth->gracefulExit(TRUE, "Missing parameter.");
			$id = $this->vars["id"];
		}
		else
		{
			$id = "new";
		}
		if(!isset($this->vars["resource_id"]))
			$this->auth->gracefulExit(TRUE, "Missing parameter.");
// If $vars['type'] is set, it will be 'web_article' in which case we dont necessarily need a page
		if(!isset($this->vars["quote"]) || !trim($this->vars['quote']) || 
			(!isset($this->vars["page"]) || !trim(is_numeric($this->vars['page']))) && 
			!isset($this->vars['type']))
		{
// Leave print as is
			print "<DIV class=\"warning\">Missing or incorrect parameter.</DIV><P>&nbsp;<P>";
			print $quoteObject->editDisplay($this->vars["resource_id"], $id);
			print "</DIV>";
			$this->auth->gracefulExit(TRUE);
		}
		if(isset($this->vars["page"]))
		{
			list($result, $pages) = $this->quotePages($this->vars["resource_id"], 
				trim($this->vars['page']));
			if(!$result)
			{
				print "<DIV class=\"warning\">Available page range for the quote is:
					&nbsp;&nbsp;$pages.</DIV><DIV CLASS=\"clear\"></DIV>";
				print $quoteObject->editDisplay($this->vars["resource_id"], $id);
				print "</DIV>";
				$this->auth->gracefulExit(TRUE);
			}
		}
	}
// manifest for adding/editing a musing
	function musing($musingObject, $edit = FALSE)
	{
		if($edit)
		{
			if(!isset($this->vars["id"]))
				$this->auth->gracefulExit(TRUE, "Missing parameter.");
			$id = $this->vars["id"];
		}
		else
		{
			$id = "new";
		}
		if(!isset($this->vars["resource_id"]))
			$this->auth->gracefulExit(TRUE, "Missing parameter.");
		if(!isset($this->vars["musing"]) || !trim($this->vars['musing']))
		{
			print "<DIV class=\"warning\">Missing or incorrect parameter.</DIV><DIV CLASS=\"clear\"></DIV>";
			print $musingObject->editDisplay($this->vars["resource_id"], $id);
			print "</DIV>";
			$this->auth->gracefulExit(TRUE);
		}
	}
// manifest for editing a note
	function note($noteObject)
	{
		if(!isset($this->vars["id"]))
			$this->auth->gracefulExit(TRUE, "Missing parameter.");
		if(!isset($this->vars["notes"]) || !$this->vars['notes'])
		{
			print "<DIV class=\"warning\">Missing or incorrect parameter.</DIV><DIV CLASS=\"clear\"></DIV>";
			print $noteObject->editDisplay($this->vars['id']);
			print "</DIV>";
			$this->auth->gracefulExit(TRUE);
		}
	}
// manifest for ordering resources
	function order($orderObject)
	{
		if(!isset($this->vars["orderMethod"]) || !$this->vars['orderMethod'])
		{
			print "<DIV class=\"warning\">Missing or incorrect parameter.</DIV><DIV CLASS=\"clear\"></DIV>";
			print $orderObject->init();
			print "</DIV>";
			$this->auth->gracefulExit(TRUE);
		}
		if($this->vars['orderMethod'] == 'orderAll')
		{
			if(isset($this->vars["orderAll"]) && $this->vars['orderAll'])
				return TRUE;
		}
		else if($this->vars['orderMethod'] == 'orderGroup')
		{
			if(isset($this->vars["orderGroup"])  && $this->vars['orderGroup'])
				return TRUE;
		}
		else if($this->vars['orderMethod'] == 'orderKeyword')
		{
			if(isset($this->vars["orderKeyword"]) && $this->vars['orderKeyword'])
				return TRUE;
		}
		else if($this->vars['orderMethod'] == 'orderWriter')
		{
			if(isset($this->vars["orderWriter"]) && $this->vars['orderWriter'])
				return TRUE;
		}
		else if($this->vars['orderMethod'] == 'orderPublisher')
		{
			if(isset($this->vars["orderPublisher"]) && $this->vars['orderPublisher'])
				return TRUE;
		}
		else if($this->vars['orderMethod'] == 'orderJournal')
		{
			if(isset($this->vars["orderJournal"]) && $this->vars['orderJournal'])
				return TRUE;
		}
		print "<DIV class=\"warning\">Missing or incorrect parameter.</DIV><DIV CLASS=\"clear\"></DIV>";
		print $orderObject->init();
		print "</DIV>";
		$this->auth->gracefulExit(TRUE);
	}
// deleting resources
	function deleteResource($object)
	{
		if(!isset($this->vars['id']) || !isset($this->vars['step']) 
			|| (($this->vars['step'] != 1) && ($this->vars['step'] != 2)))
		{
			print "<DIV class=\"warning\">Missing or incorrect parameter.</DIV>
				<DIV CLASS=\"clear\"></DIV>";
			print $object->adminResources();
			print "</DIV>";
			$this->auth->gracefulExit(TRUE);
		}
	}
}
?>
