<?php
/*****
*	Notes class
*****/
class NOTES
{
// Constructor
	function NOTES($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// display hyperlink for notes
	function displayLink($type, $id, $notes)
	{
		global $PHP_SELF;
		if($notes)
			return "<A HREF=\"" . $PHP_SELF . 
				"?action=viewNotes&id=$id\">&nbsp;N&nbsp;</A>|";
		else if($this->session->getVar('write'))
			return "<A HREF=\"" . $PHP_SELF . "?action=viewNotes&id=$id\">&nbsp;n&nbsp;</A>|";
	}
// display a resource note
	function display($id)
	{
		global $PHP_SELF;
		$condition = "WHERE resource.id=$id AND resource_notes.id=$id";
		$sql = $this->db->select('resource, resource_notes', 'title, notes', $condition);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
			return FALSE;
		$row = $this->db->fetchAssoc($sth);
		$pString = "<DIV CLASS=\"intro\"><B>" . $row['title'] . ":</B>";
		if(!$row['notes'])
		{
			$pString .= "No notes yet.</DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
		}
		else
		{
			$pString .= "</DIV><DIV CLASS=\"clear\"></DIV>";
			$pString .= "<DIV class=\"trFrame1\">";
			$pString .= stripslashes($this->nlReduce($this->toHtml($row['notes'])));
			$pString .= "</DIV>";
		}
// are we allowed to edit?
		if($this->session->getVar('write'))
		{
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editNoteDisplay\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$id\">";
			if($row['notes'])
				$pString .= "<P><INPUT TYPE=\"submit\" VALUE=\"edit\"></FORM>";
			else
				$pString .= "<P><INPUT TYPE=\"submit\" VALUE=\"add a note\"></FORM>";
		}
		$this->session->resetSession(array('finaliseNote' => FALSE));
		$pString .= $this->session->previousLink();
		return $pString;
	}
// replace newlines and carriage returns with appropriate HTML entities.
// newline characters - first multiples then singles.
	function toHtml($string)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		return $html->urlToHtml($html->nlToHtml($string));
	}
// reduce the number of newlines replacing multiples with 2 
	function nlReduce($string)
	{
		$string = preg_replace("/(\015?\012){2,}/", "\n\n", $string);
		return preg_replace("/\n/", "\n", $string);
	}
// edit a note
	function edit($id, $string)
	{
		global $PHP_SELF;
		if(!$this->session->getVar('write'))
			return FALSE;
		$notes = $this->db->tidyInput($string);
		$sql = $this->db->update('resource_notes', "notes='$notes'", "WHERE id=$id");
		if(!$this->db->query($sql))
			return FALSE;
		$sql = $this->db->update('resource', "timestamp=NULL", "WHERE id = $id");
		$this->db->query($sql);
		$pString = "Note edited successfully.";
		$pString .= "<DIV class=\"back\">Back to: <A HREF=\"" . $PHP_SELF . 
			"?action=viewNotes&id=" . $id . "\">View Note</A></DIV>";
		$this->session->resetSession(array('finaliseNote' => TRUE));
		$pString .= $this->session->previousLink();
		return $pString;
	}
// Form for editing note
	function editDisplay($id)
	{
		$pString = '';
		if($this->session->getVar('write'))
		{
			global $PHP_SELF;
			$condition = "WHERE resource.id=$id AND resource_notes.id=$id";
			$sql = $this->db->select('resource, resource_notes', 'title, notes', $condition);
			$sth = $this->db->query($sql);
			if(!$this->db->numRows($sth))
				return FALSE;
			$row = $this->db->fetchAssoc($sth);
			if(!$row['notes'])
			{
				$pString .= "<DIV class=\"back\"><A HREF=\"" . $PHP_SELF . 
					"?action=editNoteDisplay&id=" . $id . 
					"\">Reload original data</A></DIV>";
			}
			$pString .= "<DIV CLASS=\"intro\" STYLE=\"width : 75%\"><B>" . $row['title'] . ":</B></DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editNote\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$id\">";
			$pString .= "<TEXTAREA NAME=\"notes\" COLS=\"80\" ROWS=\"10\">" . 
				$this->nlReduce(stripslashes($row['notes'])) . "</TEXTAREA>";
			if($row['notes'])
				$pString .= "<P><INPUT TYPE=\"submit\" VALUE=\"edit\"></FORM>";
			else
				$pString .= "<P><INPUT TYPE=\"submit\" VALUE=\"add a note\"></FORM>";
		}
		else
		{
			$pString .= "You do not have write permissions.";
		}
		$pString .= $this->session->previousLink();
		return $pString;
	}
//  Insert notes to xxxx_notes table
	function writeSql($resourceID)
	{
		if($this->session->getVar('notes'))
			$sql = $this->db->insert('resource_notes', 'id, notes', "'$resourceID', '" . 
				$this->db->tidyInput($this->session->getVar('notes')) . "'");
		else
			$sql = $this->db->insert('resource_notes', 'id', "'$resourceID'");
		if(!$this->db->query($sql))
			return FALSE;
		$this->session->resetSession(array('finaliseNote' => TRUE));
		return TRUE;
	}
// Update xxxx_notes table
	function updateSql($resourceID)
	{
		if($this->session->getVar('notes'))
			$string = "notes='" . $this->db->tidyInput($this->session->getVar('notes')) . "'";
		else
			$string = "notes=NULL";
		$sql = $this->db->update('resource_notes', $string, "WHERE id=$resourceID");
		if(!$this->db->query($sql))
			return FALSE;
		$this->session->resetSession(array('finaliseNote' => TRUE));
		return TRUE;
	}
// Delete a note
	function deleteNote($id)
	{
		$sql = $this->db->delete('resource_notes', "WHERE id=$id");
		$this->db->query($sql);
		$this->db->optimize('resource_notes');
	}
}
?>
