<?php
/*****
*	Publisher class
*****/
class PUBLISHER
{
// Constructor
	function PUBLISHER($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// Display form fields for inputting publisher fields.
	function formFields($type)
	{
		$pString = '';
		if($this->grabAll())
		{
			$pString .= $this->preExistFormFields();
		}
		else
		{
			$pString .= "<DIV CLASS=\"tr100\"><B>Publisher:</B></DIV>";
			$pString .= "</DIV><DIV class=\"$class\">";
		}
		include_once("classes/CONFIG.php");
		$config = new CONFIG();
		include_once("classes/HTML.php");
		$html = new HTML();
		$config->getFields($type);
		$key = 'publisher_name';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr60\"><B>" . $config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"50\" MAXLENGTH=\"255\"></DIV>";
		$key = 'publisher_location';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr3\"><B>" . $config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"20\" MAXLENGTH=\"255\"></DIV>";
		$pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
		$key = 'year';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr1\"><B>" . $config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"10\" MAXLENGTH=\"9\"><BR>";
		$pString .= "<DIV class=\"hint\">(e.g. 1999 or 1903-1910)</DIV></DIV>";
		$key = 'edition';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '---';
		$newArray[0] = '---';
		for($i = 1; $i <= 20; $i++)
			$newArray[$i] = $i;
		$pString .= "<DIV CLASS=\"tr2\"><B>" . $config->fields[$key] . "</B><BR>";
		$this->session->getVar($key) ? 
			$pString .= $html->selectedBoxValue($key, $newArray, $sessVar, 5) : 
			$pString .= $html->selectFBoxValue($key, $newArray, 5);
		$pString .= "</DIV>";
		$key = 'reprint_year';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr3\"><B>" . $config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"5\" MAXLENGTH=\"4\">";
		$pString .= "<DIV class=\"hint\">(e.g. 1999)</DIV>";
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
		return $pString;
	}
// Display explanation and existing publishers in select box first.
	function preExistFormFields()
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		$id = 'publisherID';
		$newArray = array();
		$newArray[0] = 'None';
		foreach($this->pubs as $key => $value)
			$newArray[$key] = $value;
		$pString = "<DIV CLASS=\"tr60\">";
		$pString .= "<B>Publisher: </B>";
		$pString .= "<DIV CLASS=\"hint\">You may select a pre-existing publisher or enter a new one.  
			A new entry will supersede the selection of a pre-existing publisher.</DIV>";
		$pString .= "</DIV><DIV CLASS=\"tr3\">";
		$this->session->issetVar($id) ? 
			$pString .= $html->selectedBoxValue($id, $newArray, $this->session->getVar($id), 5) : 
			$pString .= $html->selectFBoxValue($id, $newArray, 5);
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV><DIV CLASS=\"trFrame1\">";
		return $pString;
	}
// write publisher table
	function writeSql()
	{
		include_once("classes/HTML.php");
		$html = new HTML();
// NB getVar() returns false if data is not set.
		if($this->session->issetVar('publisher_name'))
		{
			$publisher = trim($html->removeNl($this->session->getVar('publisher_name')));
			$location = trim($html->removeNl($this->session->getVar('publisher_location')));
			if($publisherID = $this->checkExists($publisher, $location))
				return $publisherID;
			$string = "'" . $this->db->tidyInput($publisher) . "', " . 
				"'" . $this->db->tidyInput($location) . "'";
			$sql = $this->db->insert('publisher', 'name, location', "$string");
			if(!$this->db->query($sql))
				return FALSE;
			return $this->db->lastAutoID();
		}
		else if($this->session->getVar('publisherID'))
		{
			return $this->session->getVar('publisherID');
		}
		else
		{
// set to NULL if no input.
			return 'NULL';
		}
	}
// When editing a resource, the publisher's name may be edited.  If the original publisher 
//  no longer has attached resources, remove from publisher table.
	function checkDelete($id)
	{
		$condition = "WHERE publisher=" . $id;
		$sql = $this->db->select('resource', 'publisher', $condition);
		$sth = $this->db->query($sql);
		if($this->db->numRows($sth))
			return;
// If we reach here, publisher no longer exists so delete from publisher table
		$sql = $this->db->delete('publisher', "WHERE id=" . $id);
		$this->db->query($sql);
		$this->db->optimize('publisher');
	}
// check if publisher and location already exist
	function checkExists($publisher, $location)
	{
		$sql = $this->db->select('publisher', '*');
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			if((strtolower($publisher) == strtolower($row['name'])) && 
				(strtolower($location) == strtolower($row['location'])))
					return $row['id'];
		}
		return FALSE;
	}
// grab all publisher's IDs, names and locations
	function grabAll()
	{
		$sql = $this->db->select('publisher', '*', "ORDER BY name");
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			$string = $row['name'] . ': ' . $row['location'];
			$this->pubs[$row['id']] = $string;
		}
		if($this->db->numRows($sth))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
}
?>
