<?php
/*****
*	Quotes class
*****/
class QUOTES
{
// Constructor
	function QUOTES($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// display hyperlink for quotes
	function displayLink($type, $id, $numQuotes)
	{
		global $PHP_SELF;
		if($numQuotes)
			return "<A HREF=\"" . $PHP_SELF . 
				"?action=viewQuotes&id=$id\">&nbsp;Q&nbsp;</A>|";
		else if($this->session->getVar('write'))
			return "<A HREF=\"" . $PHP_SELF . "?action=viewQuotes&id=$id\">&nbsp;q&nbsp;</A>|";
	}
// display a resource quote
	function display($id)
	{
		global $PHP_SELF;
		$pString = '';
		$string = "title, rq.id AS quoteID, quote, page, comment";
		$condition = "WHERE r.id=$id AND rq.resource_id=$id ORDER BY rq.page";
		$sql = $this->db->select('resource AS r, resource_quotes AS rq', $string, $condition);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
		{
			$pString .= "No quotes yet.";
// are we allowed to add?
			if($this->session->getVar('write'))
			{
				$pString .= "<P><HR><P>";
				$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editQuoteDisplay\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$id\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"new\">";
				$pString .= "<INPUT TYPE=\"submit\" VALUE=\"add a quote\"></FORM>";
			}
			$this->session->previousLink();
			return $pString;
		}
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
// Add the title of the resource first time through
			if(!$index)
				$pString .= "<B>" . $row['title'] . "</B>";
			($index % 2) ? $class = "table2" : $class = "table1";
			$pString .= "<DIV CLASS=\"$class\">";
			$pString .= "<DIV CLASS=\"tableLeft\">";
			$row['page'] ? $page = $row['page'] : $page = '--';
			$pString .= "Page:&nbsp;<B>" . $page . "</B><BR>";
			$pString .= "<DIV class=\"quote\">\"" . 
				$this->nlReduce($this->toHtml(stripslashes($row['quote']))) . "\"</DIV>";
			if($row['comment'])
				$pString .= "<DIV class=\"comment\">" . 
				$this->nlReduce($this->toHtml(stripslashes($row['comment']))) . "</DIV>";
			$pString .= "</DIV>";
// are we allowed to edit?
			$pString .= "<DIV CLASS=\"tableRight\">";
			if($this->session->getVar('write'))
			{
				$pString .= "<A HREF=\"" . $PHP_SELF . 
					"?action=editQuoteDisplay&resource_id=$id&id=" . 
					$row['quoteID'] . "\">E</A>&nbsp;";
			}
			$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV>";
			++$index;
		}
// are we allowed to add?
		if($this->session->getVar('write'))
		{
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editQuoteDisplay\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$id\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"new\">";
			$pString .= "<INPUT TYPE=\"submit\" VALUE=\"add a quote\"></FORM>";
		}
		$pString .= $this->session->previousLink();
		return $pString;
	}
// replace newlines and carriage returns with appropriate HTML entities.
// newline characters - first multiples then singles.
	function toHtml($string)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		return $html->urlToHtml($html->nlToHtml($string));
	}
// reduce the number of newlines replacing multiples with 2 
	function nlReduce($string)
	{
		$string = preg_replace("/(\015?\012){2,}/", "\n\n", $string);
		return preg_replace("/\n/", "\n", $string);
	}
// add a quote
	function add($vars)
	{
		global $PHP_SELF;
		$sqlKey = "resource_id, quote, page";
		$sqlValue = $vars['resource_id'] . ", '" . $this->db->tidyInput($vars['quote']) . "', '" . 
			$this->db->tidyInput($vars['page']) . "'";
		if($vars['comment'])
		{
			$sqlKey .= ", comment";
			$sqlValue .= ", '" . $this->db->tidyInput($vars['comment']) . "'";
		}
		$sql = $this->db->insert('resource_quotes', $sqlKey, $sqlValue);
		if(!$this->db->query($sql))
			return FALSE;
		$pString = "Quote added successfully.";
		$pString .= "<DIV class=\"back\">Back to: <A HREF=\"" . $PHP_SELF . 
			"?action=viewQuotes&id=" . $vars['resource_id'] . "\">View Quotes</A></DIV>";
		$pString .= $this->session->previousLink();
		$this->summary($vars['resource_id']);
// reset the session variables to forestall reloading + rewriting of this quote to database.
		$this->session->resetSession(array('finaliseQuote' => TRUE));
		return $pString;
	}
// edit a quote
	function edit($resourceID, $id, $vars)
	{
		global $PHP_SELF;
		if(!$this->session->getVar('write'))
			return FALSE;
		$quote = $this->db->tidyInput($vars['quote']);
		$string = "quote='$quote', page='" . $vars['page'] . "'";
// NB, if $vars['comment'] is NULL, we assume this is deleting the comment column in the table.
		if($vars['comment'])
			$string .= ", comment='" . $this->db->tidyInput($vars['comment']) . "'";
		else
			$string .= ", comment=NULL";
		$sql = $this->db->update('resource_quotes', "$string", "WHERE id=$id");
		if(!$this->db->query($sql))
			return FALSE;
		$sql = $this->db->update('resource', "timestamp=NULL", "WHERE id = $resourceID");
		$this->db->query($sql);
		$pString = "Quote edited successfully.";
		$pString .= "<DIV class=\"back\">Back to: <A HREF=\"" . $PHP_SELF . 
			"?action=viewQuotes&id=" . $vars['resource_id'] . "\">View Quotes</A></DIV>";
		$pString .= $this->session->previousLink();
// reset the session variables to forestall reloading + rewriting of this quote to database.
		$this->session->resetSession(array('finaliseQuote' => TRUE));
		return $pString;
	}
// Form for editing quote (also adding a quote)
	function editDisplay($resourceID, $id)
	{
		$pString = '';
		if($this->session->getVar('write'))
		{
			global $PHP_SELF;
			$sql = $this->db->select('resource', 'type, title', "WHERE id=$resourceID");
			$sth = $this->db->query($sql);
			if(!$this->db->numRows($sth))
				return FALSE;
			$row = $this->db->fetchAssoc($sth);
			if($id != 'new')
			{
				$pString .= "<DIV class=\"back\"><A HREF=\"" . $PHP_SELF . 
					"?action=editQuoteDisplay&id=" . $id . 
					"&resource_id=$resourceID\">Reload original data</A></DIV>";
			}
			$pString .= "<DIV CLASS=\"intro\" STYLE=\"width : 75%\"><B>" . $row['title'] . ":</B><P>";
			$pString .= "[*] = required.<P></DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
// page no.s not required for web_articles
			if($row['type'] == 'web_article')
			{
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"type\" VALUE=\"web_article\">";
				$pageReq = '';
			}
			else
			{
				$pageReq = '*';
			}
// reset the session variable finalise flag
			$this->session->setVar('finaliseQuote', FALSE);
// add a new quote?
			if($id == 'new')
			{
				($quote = trim($this->session->getVar('quote'))) ? FALSE : $quote = '';
				($page = trim($this->session->getVar('page'))) ? TRUE : $page = '';
				$page ? TRUE : $page = '';
				($comment = trim($this->session->getVar('comment'))) ? FALSE : $comment = '';
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"addQuote\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$resourceID\">";
				$pString .= "* Quote:<BR>
					<TEXTAREA NAME=\"quote\" COLS=\"80\" ROWS=\"10\">$quote</TEXTAREA><P>";
				$pString .= "$pageReq Page no.:&nbsp;<INPUT TYPE=\"text\" NAME=\"page\" VALUE=\"$page\" 
					SIZE=\"5\" MAXLENGTH=\"4\"><P>";
				$pString .= "Comment on quote:<BR>
					<TEXTAREA NAME=\"comment\" COLS=\"80\" ROWS=\"10\">$comment</TEXTAREA><P>";
				$pString .= "<INPUT TYPE=\"submit\" VALUE=\"add a quote\"></FORM>";
			}
// or editing existing quote?
			else
			{
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editQuote\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$id\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$resourceID\">";
				$sql = $this->db->select('resource_quotes', 'quote, page, comment', "WHERE id=$id");
				$sth = $this->db->query($sql);
				while($result = $this->db->fetchAssoc($sth))
				{
					($quote = trim($this->session->getVar('quote'))) ? FALSE : 
						$quote = $this->nlReduce(stripslashes($result['quote']));
					($page = trim($this->session->getVar('page'))) ? TRUE : 
						$page = $result['page'];
					$page ? TRUE : $page = '';
					($comment = trim($this->session->getVar('comment'))) ? FALSE : 
						$comment = $this->nlReduce(stripslashes($result['comment']));
					$pString .= "* Quote:<BR>
						<TEXTAREA NAME=\"quote\" COLS=\"80\" 
						ROWS=\"10\">$quote</TEXTAREA><P>";
					$pString .= "$pageReq Page no.:&nbsp;<INPUT TYPE=\"text\" NAME=\"page\" 
						VALUE=\"$page\" SIZE=\"5\" MAXLENGTH=\"4\"><P>";
					$pString .= "Comment on quote:<BR>
						<TEXTAREA NAME=\"comment\" COLS=\"80\" 
						ROWS=\"10\">$comment</TEXTAREA><P>";
				}
				$pString .= "<P><INPUT TYPE=\"submit\" VALUE=\"edit\"></FORM>";
			}
		}
		else
		{
			$pString .= "You do not have write permissions.";
		}
		$pString .= $this->session->previousLink();
		return $pString;
	}
// update total_quotes in summary table and update num_quotes in resource table
	function summary($id)
	{
		$sql = $this->db->update('summary', "total_quotes = total_quotes + 1");
		$this->db->query($sql);
		$sql = $this->db->update('resource', "timestamp=NULL, num_quotes = num_quotes + 1", "WHERE id = $id");
		$this->db->query($sql);
	}
// delete quotes
	function deleteQuotes($id)
	{
		$sql = $this->db->delete('resource_quotes', "WHERE resource_id=" . $id);
		$this->db->query($sql);
		$this->db->optimize('resource_quotes');
		$sql = $this->db->update('summary', "total_quotes = total_quotes - 1");
		$this->db->query($sql);
	}
}
?>
