<?php
/*****
* RESOURCE class
*****/
class RESOURCE
{
// Constructor
	function RESOURCE($db, $auth, $vars)
	{
		$this->db = $db;
		$this->auth = $auth;
		$this->vars = $vars;
		include_once("classes/CONFIG.php");
		$this->config = new CONFIG();
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		include_once("classes/MANIFEST.php");
		$this->manifest = new MANIFEST($this, $db, $auth, $vars);
	}
// decide which part to display based on $this->vars['step'] - if not set, start from top
	function parse()
	{
		if(!isset($this->vars['step']))
		{
// reset session
			$this->session->resetSession(array('finaliseResource' => TRUE));
			return $this->displayForm1();
		}
		else if($this->vars['step'] == 2)
		{
			return $this->displayForm2();
		}
		else if($this->vars['step'] == 3)
		{
			return $this->displayForm3();
		}
		else if($this->vars['step'] == 4)
		{
			return $this->finalise();
		}
		else
		{
			$this->auth->gracefulExit(TRUE, 'Missing parameter.');
		}
	}
// Display form for inputting a new resource: step 1.
	function displayForm1()
	{
		global $PHP_SELF;
// load resource types
		$this->config->resourceTypes();
		include_once("classes/HTML.php");
		$html = new HTML();
		$pString = "<DIV CLASS=\"intro\"><B>New Resource ~ step 1</B><P>";
// a bit of explanation
		$pString .= "There are a number of steps to this procedure. Here, enter the <B>type</B> 
			and <B>title</B> of the resource. If your resource is, for example, an 
			article or a chapter within a book, you would enter the <B>article</B> title here.<P>";
		$pString .= "Under <B>writers</B>, select the number of authors and or editors the resource has 
			and, for books and book articles, the number of translators and revisers.<P>";
		$pString .= "Do not put any punctuation at either the start or end of these entries (with 
			the exception of notes): the wikindx will punctuate accordingly.<P>
			'*' = required.<P>";
		$pString .= "It is your responsibility to capitalize titles and names accordingly.</DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= "<DIV class =\"trFrame1\">";
		$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"newResource\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"step\" VALUE=\"2\">";
		$pString .= "<DIV CLASS=\"tr15\"><B>Type:</B><BR>";
// display select box of resource Types
		if($type = $this->session->getVar('type'))
		{
			$pString .= $html->selectedBoxValue('type', $this->config->types, $type, 4);
		}
		else
		{
			$pString .= $html->selectFBoxValue('type', $this->config->types, 4);
		}
		$pString .= "</DIV>";
		$pString .= "<DIV CLASS=\"tr40\"><B>Title:</B><BR>";
// display title text box
		if($title = $this->session->getVar('title'))
		{
			$pString .= "<INPUT TYPE=\"text\" NAME=\"title\" 
				VALUE=\"$title\" SIZE=\"50\" MAXLENGTH=\"255\">*";
		}
		else
		{
			$pString .= "<INPUT TYPE=\"text\" NAME=\"title\" SIZE=\"50\" MAXLENGTH=\"255\">*";
		}
// display subtitle text box
		$pString .= "<P><B>Subtitle:</B><BR>";
		if($title = $this->session->getVar('subtitle'))
		{
			$pString .= "<INPUT TYPE=\"text\" NAME=\"subtitle\" 
				VALUE=\"$title\" SIZE=\"50\" MAXLENGTH=\"255\">";
		}
		else
		{
			$pString .= "<INPUT TYPE=\"text\" NAME=\"subtitle\" SIZE=\"50\" MAXLENGTH=\"255\">";
		}
		$pString .= "</DIV>";
		$pString .= "<DIV CLASS=\"tr40\"><B>Writers:</B><P>";
		$pString .= $this->displayWriterSelectBoxes();
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV>";
		$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"proceed\"></FORM></DIV>";
		return $pString;
	}
// Display select boxes for inputting no. of writers
	function displayWriterSelectBoxes()
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		$pString = "<DIV STYLE=\"float : left; margin : 0 0.5em\">Authors:<BR>";
		if($num = $this->session->getVar('numAuthors'))
		{
			$pString .= $html->selectedBoxValue('numAuthors', range(0, 6), $num, 3);
		}
		else
		{
			$pString .= $html->selectFBoxValue('numAuthors', range(0, 6), 3);
		}
		$pString .= "</DIV><DIV STYLE=\"float : left; margin : 0 0.5em\">Editors:<BR>";
		if($num = $this->session->getVar('numEditors'))
		{
			$pString .= $html->selectedBoxValue('numEditors', range(0, 6), $num, 3);
		}
		else
		{
			$pString .= $html->selectFBoxValue('numEditors', range(0, 6), 3);
		}
		$pString .= "</DIV><DIV STYLE=\"float : left; margin : 0 0.5em\">Translators:<BR>";
		if($num = $this->session->getVar('numTranslators'))
		{
			$pString .= $html->selectedBoxValue('numTranslators', range(0, 3), $num, 3);
		}
		else
		{
			$pString .= $html->selectFBoxValue('numTranslators', range(0, 3), 3);
		}
		$pString .= "</DIV><DIV STYLE=\"float : left; margin : 0 0.5em\">Revisers:<BR>";
		if($num = $this->session->getVar('numRevisers'))
		{
			$pString .= $html->selectedBoxValue('numRevisers', range(0, 3), $num, 3);
		}
		else
		{
			$pString .= $html->selectFBoxValue('numRevisers', range(0, 3), 3);
		}
		$pString .= "</DIV>";
		return $pString;
	}
// Display form for inputting a new resource: step 2.
// If $firstTime == TRUE, form fields should be blank.  Otherwise, user has missed some entry 
// on previous input and form fields should be filled in via session data.
	function displayForm2($firstTime = TRUE)
	{
		if($firstTime)
		{
			$this->gatherForm1();
			$this->manifest->title();
			$this->manifest->writers($this->vars['type']);
			$inputType = $this->vars['type'];
		}
		else
		{
			$inputType = $this->session->getVar('type');
		}
// load resource types
		$this->config->resourceTypes();
		$pString = "<DIV CLASS=\"intro\"><B>New Resource ~ step 2</B></DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		global $PHP_SELF;
		$pString .= "<DIV class=\"trFrame1\">";
		$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"newResource\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"step\" VALUE=\"3\">";
		foreach($this->config->types as $type => $value)
		{
			if($string = $this->displayForm2Fields($inputType, $type))
			{
				$pString .= $string;
				break;
			}
		}
		$this->session->getVar('notes') ?
			$sessVar = $this->session->getVar('notes') : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr60\"><B>General notes or comments</B><BR>
			<TEXTAREA NAME=\"notes\" COLS=\"60\" ROWS=\"8\">$sessVar</TEXTAREA></DIV>";
		$pString .= "</DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= $this->submitButton();
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		return $pString;
	}
// Print to the browser the required form fields for Step 2
	function displayForm2Fields($inputType, $type)
	{
		include_once("classes/AUTHOR.php");
		$author = new AUTHOR($this->db);
		include_once("classes/EDITOR.php");
		$editor = new EDITOR($this->db);
		include_once("classes/JOURNAL.php");
		include_once("classes/BOOK.php");
		include_once("classes/PUBLISHER.php");
		$pub = new PUBLISHER($this->db);
		if($inputType == $type)
		{
			$this->config->getFields($type);
			$pString = $author->formFields($type);
			if($type == 'book')
			{
				$pString .= $editor->formFields($type);
				$pString .= $editor->transFields($type, 'translator1');
				$pString .= $editor->revFields($type, 'reviser1');
				$book = new BOOK($this->db);
				$pString .= $book->formFields($this->config->fields);
				$pString .= $book->series();
				$pString .= $pub->formFields('book');
				$pString .= $book->volumes();
			}
			else if($type == 'book_article')
			{
				$pString .= $editor->formFields($type);
				$pString .= $editor->transFields($type, 'translator1');
				$pString .= $editor->revFields($type, 'reviser1');
				$book = new BOOK($this->db, TRUE);
				$pString .= $book->formFields($this->config->fields);
				$pString .= $book->series();
				$pString .= $pub->formFields('book_article');
				$pString .= $book->volumes();
			}
			else if($type == 'journal_article')
			{
				$journal = new JOURNAL($this->db);
				$pString .= $journal->formFields($this->config->fields);
			}
			else if($type == 'web_article')
			{
				$journal = new JOURNAL($this->db, TRUE);
				$pString .= $journal->formFields($this->config->fields);
			}
			return $pString;
		}
		return FALSE;
	}
// display form 3 - groups and keyword input
	function displayForm3($firstTime = TRUE)
	{
		global $PHP_SELF;
		include_once("classes/GROUP.php");
		$group = new GROUP($this->db);
		include_once("classes/KEYWORD.php");
		$keyword = new KEYWORD($this->db);
		if($firstTime)
			$this->gatherForm2();
		$pString = "<DIV CLASS=\"intro\"><B>New Resource ~ step 3</B><P></DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"newResource\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"step\" VALUE=\"4\">";
		$pString .= $group->formfields();
		$pString .= "<DIV CLASS=\"clear\"><HR></DIV>";
		$pString .= $keyword->formFields();
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= $this->submitButton();
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		return $pString;
	}
// gather step 1 input
	function gatherForm1()
	{
		$array = array('type', 'title', 'subtitle', 'numAuthors', 'numEditors', 'numTranslators', 
			'numRevisers',);
// write these details to the session
// reset the session variable finalise flag
		$this->session->setVar('finaliseResource', FALSE);
		foreach($array as $key)
		{
			if(!$this->session->setVar($key, trim($this->vars[$key])))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
	}
// gather step 2 input and simply write to session
	function gatherForm2()
	{
// if session variable 'finaliseResource' is TRUE, user is simply reloading this form
		if($this->session->getVar('finaliseResource'))
			$this->auth->gracefulExit(TRUE, 'You have already created this resource.');
		$type = $this->session->getVar('type');
// write whatever has been input to session variables
		$this->config->getFields($type);
		foreach($this->config->fields as $key => $value)
		{
			if(isset($this->vars[$key]) && $this->vars[$key])
			{
				if(!$this->session->setVar($key, trim($this->vars[$key])))
					$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
			}
			if(!isset($this->vars[$key]) && $this->session->issetVar($key))
				$this->session->delVar($key);
			else if(isset($this->vars[$key]) && !$this->vars[$key] && $this->session->issetVar($key))
				$this->session->delVar($key);
		}
// check for any notes input
		if($this->vars['notes'])
		{
			if(!$this->session->setVar('notes', trim($this->vars['notes'])))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		if(!$this->vars['notes'] && $this->session->issetVar('notes'))
			$this->session->delVar('notes');
		$this->preExistSession($type);
		if(!$this->manifest->author($type))
		{
// Leave print as is
			print $this->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if(!$this->manifest->editor())
		{
// Leave print as is
			print $this->displayForm2(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if(($type == 'book_article') || ($type == 'journal_article'))
			$this->manifest->page();
		if($type == 'web_article')
		{
			$this->manifest->webAddress();
			$this->manifest->dateAccess();
			$this->manifest->year('year');
		}
		if($type == 'book_article')
			$this->manifest->title2('book_title');
		if($type == 'journal_article')
		{
			$this->manifest->title2('journal_title');
			$this->manifest->year('year');
		}
		if(($type == 'book_article') || ($type == 'book'))
		{
			$this->manifest->year('volume_year');
			$this->manifest->year('reprint_year');
			$this->manifest->publisher();
			$this->manifest->volume();
			$this->manifest->series();
		}
	}
// gather step 3 input and write to session.  Relates only to groups and keywords
	function gatherForm3()
	{
// selectGroup is a multiple select box so handle as array
		if(isset($this->vars['selectGroup']) && $this->vars['selectGroup'])
		{
			if(!$this->session->setVar('selectGroup', trim(implode(',', $this->vars['selectGroup']))))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		else
		{
// This print must print from here as we don't return to DISPLAY class!
			print $this->displayForm3(FALSE);
			$this->auth->gracefulExit(TRUE);
		}
// selectKeyword is a multiple select box so handle as array
		if(isset($this->vars['selectKeyword']) && $this->vars['selectKeyword'])
		{
			if(!$this->session->setVar('selectKeyword', trim(implode(',', $this->vars['selectKeyword']))))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		if(isset($this->vars['boxKeyword']) && $this->vars['boxKeyword'])
		{
			if(!$this->session->setVar('boxKeyword', trim($this->vars['boxKeyword'])))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
	}
// Display form for inputting a new resource: step 3
	function finalise()
	{
// if session variable 'finaliseResource' is TRUE, user is simply reloading this form
		if($this->session->getVar('finaliseResource'))
			$this->auth->gracefulExit(TRUE, 'You have already created this resource.');
		$this->gatherForm3();
// write to resources table
		include_once("classes/BOOK.php");
		$book = new BOOK($this->db);
		if(!$book->writeSql())
			$this->auth->gracefulExit(TRUE, 'Unable to write to database.');
		$pString = "New resource created. Thank you.";
		$this->session->resetSession(array('finaliseResource' => TRUE));
		return $pString;
	}
// check for special cases like choices of pre-existing authors, editors and publishers and write to session
	function preExistSession($type)
	{
		$array =  array('author1ID', 'author2ID', 'author3ID', 'author4ID', 'author5ID', 'author6ID',);
		if(($type == 'journal_article') || ($type == 'web_article'))
			array_push($array, 'journalID');
		else
			array_push($array, 'editor1ID', 'editor2ID', 'editor3ID', 'editor4ID', 'editor5ID', 
				'editor6ID', 'publisherID', 'translator1ID', 'translator2ID', 'translator3ID', 
				'reviser1ID', 'reviser2ID', 'reviser3ID');
		foreach($array as $key)
		{
			if(isset($this->vars[$key]))
			{
				if(!$this->session->setVar($key, trim($this->vars[$key])))
					$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
			}
			if(!isset($this->vars[$key]) && $this->session->issetVar($key))
				$this->session->delVar($key);
		}
	}
// print submit button
	function submitButton($numBlankCells = 0)
	{
		$pString = '';
		$pString .= "<DIV ALIGN=\"right\">
			<INPUT TYPE=\"submit\" VALUE=\"proceed\"></FORM></DIV>";
		return $pString;
	}
// Display edit hyperlink
	function editDisplayLink($id)
	{
		global $PHP_SELF;
		return "<A HREF=\"" . $PHP_SELF . "?action=editResourceDisplay&id=$id\">&nbsp;E&nbsp;</A>";
	}
// display resource for editing
	function editDisplay($row, $firstTime = TRUE)
	{
		global $PHP_SELF;
		$this->config->resourceTypes();
// reset session
		if($firstTime)
		{
			$this->session->resetSession(array('finaliseResourceEdit' => FALSE));
// reset the session variable finalise flag
//			$this->session->setVar('finaliseResourceEdit', FALSE);
			$this->writeSession($row);
		}
// a bit of explanation
		$pString = "Do not put any punctuation at either the start or end of these entries (with 
			the exception of notes): the wikindx will punctuate accordingly.<P>
			'*' = required.<P>";
		$pString .= "It is your responsibility to capitalize titles and names accordingly.<P>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= "<DIV class=\"trFrame2\">";
		$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editResource\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"" . $row['resourceID'] . "\">";
		$pString .= "<DIV class=\"tr1\"><B>" . $this->config->types[$row['type']] . "</B></DIV>";
		$pString .= "<DIV class=\"tr60\"><B>Title:</B><BR><INPUT TYPE=\"text\" NAME=\"title\" 
				VALUE=\"" . $row['title'] . "\" SIZE=\"50\" MAXLENGTH=\"255\">*<P>";
// display subtitle text box
		$pString .= "<B>Subtitle:</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"subtitle\" 
				VALUE=\"" . $row['subtitle'] . "\" SIZE=\"50\" MAXLENGTH=\"255\"></DIV>";
		$pString .= "</DIV><DIV CLASS=\"clear\"><HR></DIV><DIV class=\"trFrame1\">";
		foreach($this->config->types as $type => $value)
		{
			if($string = $this->displayForm2Fields($row['type'], $type))
			{
				$pString .= $string;
				break;
			}
		}
		$this->session->getVar('notes') ?
			$sessVar = $this->session->getVar('notes') : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr60\"><B>General notes or comments</B><BR>
			<TEXTAREA NAME=\"notes\" COLS=\"60\" ROWS=\"8\">$sessVar</TEXTAREA></DIV>";
		$pString .= "</DIV><DIV CLASS=\"clear\"><HR></DIV>";
		include_once("classes/KEYWORD.php");
		$keyword = new KEYWORD($this->db);
		include_once("classes/GROUP.php");
		$group = new GROUP($this->db);
		$pString .= $group->formfieldsEdit($row['resourceID']);
		$pString .= "<DIV CLASS=\"clear\"><HR></DIV>";
		$pString .= $keyword->formFieldsEdit($row['resourceID']);
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"&nbsp;edit&nbsp;\"></FORM></DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		return $pString;
	}
// recall data and write to session in preparation for form display and editing of resource details
	function writeSession($row)
	{
		foreach($row as $key => $value)
		{
			if($row[$key])
			{
				if(!$this->session->setVar($key, $row[$key]))
					$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
			}
		}
		$this->writeSessionNotes($row['resourceID']);
	}
// write session details for notes
	function writeSessionNotes($id)
	{
		$sql = $this->db->select('resource_notes', 'notes', "WHERE id=$id");
		$sth = $this->db->query($sql);
		if($notes = $this->db->fetchOne($sth))
			if(!$this->session->setVar('notes', $notes))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
	}
// edit a resource.
	function edit($displayObject, $id)
	{
// if session variable 'finaliseResourceEdit' is TRUE, user is simply reloading this form
		if($this->session->getVar('finaliseResourceEdit'))
			$this->auth->gracefulExit(TRUE, 'You have already edited this resource.');
		$type = $this->session->getVar('type');
		$this->writeEditSession($type);
		if(!$this->manifest->checkTitleEdit($type, $id))
		{
// leave print as is
			print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if(!$this->manifest->author($type))
		{
			print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if(!$this->manifest->editor())
		{
			print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
			$this->auth->gracefulExit(TRUE);
		}
		if(($type == 'book_article') || ($type == 'journal_article'))
		{
			if(!$this->manifest->page(TRUE))
			{
				print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
				$this->auth->gracefulExit(TRUE);
			}
		}
		if($type == 'web_article')
		{
			if(!$this->manifest->webAddress(TRUE) || 
				!$this->manifest->dateAccess(TRUE) || !$this->manifest->year('year', TRUE))
			{
				print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
				$this->auth->gracefulExit(TRUE);
			}
		}
		if($type == 'book_article')
		{
			if(!$this->manifest->title2('book_title', TRUE))
			{
				print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
				$this->auth->gracefulExit(TRUE);
			}
		}
		if($type == 'journal_article')
		{
			if(!$this->manifest->title2('journal_title', TRUE) || !$this->manifest->year('year', TRUE))
			{
				print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
				$this->auth->gracefulExit(TRUE);
			}
		}
		if(($type == 'book_article') || ($type == 'book'))
		{
			if(!$this->manifest->year('volume_year', TRUE) || 
				!$this->manifest->year('reprint_year', TRUE) || 
				!$this->manifest->volume(TRUE) || 
				!$this->manifest->publisher(TRUE) || 
				!$this->manifest->series(TRUE))
			{
				print $this->editDisplay($displayObject->editResourceDisplaySql($id), FALSE);
				$this->auth->gracefulExit(TRUE);
			}
		}
		include_once("classes/BOOK.php");
		$book = new BOOK($this->db, TRUE);
		if(!$book->updateSql($id, $type))
			$this->auth->gracefulExit(TRUE, 'Unable to update database.');
		$pString = "<DIV CLASS=\"intro\">Resource successfully edited.</DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$this->session->resetSession(array('finaliseResourceEdit' => TRUE));
		return $pString;
	}
// write edit details to session
	function writeEditSession($type)
	{
		if(!$this->session->setVar('title', trim($this->vars['title'])))
			$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		if(!$this->session->setVar('subtitle', trim($this->vars['subtitle'])))
			$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		$this->config->getFields($type);
		foreach($this->config->fields as $key => $value)
		{
			if(isset($this->vars[$key]) && $this->vars[$key])
			{
				if(!$this->session->setVar($key, trim($this->vars[$key])))
					$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
			}
			if(!isset($this->vars[$key]) && $this->session->issetVar($key))
				$this->session->delVar($key);
			else if(isset($this->vars[$key]) && !$this->vars[$key] && $this->session->issetVar($key))
				$this->session->delVar($key);
		}
// check for any notes input
		if($this->vars['notes'])
		{
			if(!$this->session->setVar('notes', trim($this->vars['notes'])))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		else if($this->session->issetVar('notes'))
		{
			$this->session->delVar('notes');
		}
// Groups input
// selectGroup is a multiple select box so handle as array
		if(isset($this->vars['selectGroup']) && $this->vars['selectGroup'])
		{
			if(!$this->session->setVar('selectGroup', trim(implode(',', $this->vars['selectGroup']))))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		else
		{
			$this->editDisplay($type, $title, $id, FALSE);
			$this->auth->gracefulExit(TRUE);
		}
// Keywords Input
// 'selectKeyword is a multiple select box so handle as array
		if(isset($this->vars['selectKeyword']) && $this->vars['selectKeyword'])
		{
			if(!$this->session->setVar('selectKeyword', trim(implode(',', $this->vars['selectKeyword']))))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		else if(isset($this->vars['selectKeyword']) && ($this->vars['selectKeyword'] == 'None'))
		{
			$this->session->delVar('selectKeyword');
		}
		else if(!isset($this->vars['selectKeyword']) || !$this->vars['selectKeyword'])
		{
			$this->session->delVar('selectKeyword');
		}
		if(isset($this->vars['boxKeyword']) && $this->vars['boxKeyword'])
		{
			if(!$this->session->setVar('boxKeyword', trim($this->vars['boxKeyword'])))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		$this->preExistSession($type);
	}
}
?>
