<?php
/*****
*	Search class
*****/
class SEARCH
{
// Constructor
	function SEARCH($db, $auth, $vars)
	{
		$this->db = $db;
		$this->auth = $auth;
		$this->vars = $vars;
		$this->sth = '';
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		include_once("classes/CONFIG.php");
		$config = new CONFIG();
		$this->params1 = array('searchBook', 'searchBookArticle', 
						'searchJournalArticle', 'searchWebArticle',);
		$this->params2 = array('searchTitle', 'searchNote', 'searchQuote', 
						'searchQComment', 'searchMusing',);
		$this->params4 = array('searchGroupMethod', 'searchKeywordMethod',);
		$this->types = array(
					'searchBook'		=>	'book',
					'searchBookArticle'	=>	'book_article', 
					'searchJournalArticle'	=>	'journal_article',
					'searchWebArticle'	=>	'web_article',
				);
		$this->tables1 = array(
					'searchBook'			=>	'book',
					'searchBookArticle'		=>	'book_article',
					'searchJournalArticle'		=>	'journal_article',
					'searchWebArticle'		=>	'web_article',
				);
		$this->tables2 = array(
					'searchNote'		=>	'resource_notes',
					'searchQuote'		=>	'resource_quotes',
					'searchQComment'	=>	'resource_quotes',
					'searchMusing'		=>	'musings',
				);
		$this->tableStmt = array(
					'searchMusing'		=>	'm',
					'searchNote'		=>	'rn',
					'searchQuote'		=>	'rq',
					'searchQComment'	=>	'rq',
				);
		$config->commonSql('all');
		$this->stmt = $config->stmt;
		$this->stmt .= ", num_quotes, num_musings, notes";
		$this->condition = $config->condition;	
	}
// Display various search options no. 1
	function init1()
	{
		global $PHP_SELF;
		global $WIKINDX_GROUPS;
		include_once("classes/HTML.php");
		$html = new HTML();
		include_once("classes/KEYWORD.php");
		$keyword = new KEYWORD($this->db);
		$this->readSession(1);
		$keywords = FALSE;
		$groups = FALSE;
		if($sth = $keyword->grabAll())
		{
			while($result = $this->db->fetchAssoc($sth))
			{
				$assoc[$result['id']] = $result['keyword'];
			}
			$newArrayK = array();
			$newArrayK[0] = 'IGNORE';
			foreach($assoc as $key => $value)
				$newArrayK[$key] = $value;
			$keywords = TRUE;
		}
		$pString = "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
		$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"search\">";
		if(sizeof($WIKINDX_GROUPS) > 1)
			$groups = TRUE;
		if(!$keywords && !$groups)
		{
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchGroup\" VALUE=\"0\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchGroupMethod\" VALUE=\"1\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchKeyword\" VALUE=\"0\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchKeywordMethod\" VALUE=\"1\">";
			return;
		}
		$newArrayG = array();
		$newArrayG[0] = 'IGNORE';
		foreach($WIKINDX_GROUPS as $key => $value)
			$newArrayG[$key] = $value;
		if($groups)
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<B>Groups</B><BR>";
			if(!isset($this->searchGroup) || !$this->searchGroup[0])
				$pString .= $html->selectFBoxValueMultiple('searchGroup[]', $newArrayG, $size = 5);
			else
				$pString .= $html->selectedBoxValueMultiple('searchGroup[]', $newArrayG, 
					$this->searchGroup, $size = 5);
			$pString .= "<DIV CLASS=\"hint\">(Multiples can be chosen.)</DIV>";
			$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchGroupMethod\" VALUE=\"OR\" ";
			$this->searchGroupMethod == 'OR' ? ($pString .= " CHECKED>") : ($pString .= ">");
			$pString .= "OR<BR>";
			$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchGroupMethod\" VALUE=\"AND\" ";
			$this->searchGroupMethod == 'AND' ? ($pString .= " CHECKED>") : ($pString .= ">");
			$pString .= "AND";
			$pString .= "</DIV>";
		}
// Only one group exists, send dummy values ('searchGroup' must be 1).
		else
		{
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchGroup\" VALUE=\"1\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchGroupMethod\" VALUE=\"1\">";
		}
		if($keywords)
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<B>Keywords</B><BR>";
			if(!isset($this->searchKeyword) || !$this->searchKeyword[0])
				$pString .= $html->selectFBoxValueMultiple('searchKeyword[]', $newArrayK, $size = 5);
			else
				$pString .= $html->selectedBoxValueMultiple('searchKeyword[]', $newArrayK, 
					$this->searchKeyword, $size = 5);
			$pString .= "<DIV CLASS=\"hint\">(Multiples can be chosen.)</DIV>";
			$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchKeywordMethod\" VALUE=\"OR\" ";
			$this->searchKeywordMethod == 'OR' ? ($pString .= " CHECKED>") : ($pString .= ">");
			$pString .= "OR<BR>";
			$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchKeywordMethod\" VALUE=\"AND\" ";
			$this->searchKeywordMethod == 'AND' ? ($pString .= " CHECKED>") : ($pString .= ">");
			$pString .= "AND";
			$pString .= "</DIV>";
		}
// If no keywords have yet been set, send dummy values.
		else
		{
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchKeyword\" VALUE=\"0\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"searchKeywordMethod\" VALUE=\"1\">";
		}
		$pString .= "<DIV CLASS=\"clear\"><HR></DIV>";
		return $pString;
	}
// Display various search options no. 2
	function init2()
	{
		global $PHP_SELF;
		$this->readSession(2);
		$pString = "<DIV CLASS=\"searchtext\">";
		$pString .= "<B>Resource type</B><BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchBook\" " . $this->searchBook . ">&nbsp;Books<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchBookArticle\" " . 
			$this->searchBookArticle . ">&nbsp;Book articles<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchJournalArticle\" " . 
			$this->searchJournalArticle . ">&nbsp;Journal articles<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchWebArticle\" " . 
			$this->searchWebArticle . ">&nbsp;Web articles<BR>";
		$pString .= "<DIV CLASS=\"hint\">(None is equivalent to all.)</DIV>";
		$pString .= "</DIV>";
		$pString .= "<DIV CLASS=\"searchtext\">";
		$pString .= "<B>Location</B><BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchTitle\" " . $this->searchTitle . 
			">&nbsp;Titles<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchNote\" " . $this->searchNote . 
			">&nbsp;Notes<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchQuote\" " . $this->searchQuote . 
			">&nbsp;Quotes<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchQComment\" " . $this->searchQComment . 
			">&nbsp;Quote Comments<BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchMusing\" " . $this->searchMusing . 
			">&nbsp;Musings<BR>";
		$pString .= "<DIV CLASS=\"hint\">(None is equivalent to all.)</DIV>";
		$pString .= "</DIV>";

		$pString .= "<DIV CLASS=\"searchtext\">";
		$pString .= "<B>Search word(s)</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"searchTerm\"  
			VALUE=\"" . $this->searchTerm . "\" SIZE=\"40\"><BR>";
		$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"searchPartial\" " . $this->searchPartial . ">
			&nbsp;Partial word(s)";
		$pString .= "</DIV>";

		$pString .= "<DIV CLASS=\"searchtext\">";
		$pString .= "<B>Search method</B><BR>";
		$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchMethod\" VALUE=\"phrase\" ";
		$this->searchMethod == 'phrase' ? ($pString .= " CHECKED>") : ($pString .= ">");
		$pString .= "Exact phrase<BR>";
		$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchMethod\" VALUE=\"all\" ";
		$this->searchMethod == 'all' ? ($pString .= " CHECKED>") : ($pString .= ">");
		$pString .= "AND<BR>";
		$pString .= "<INPUT TYPE=\"radio\" NAME=\"searchMethod\" VALUE=\"any\" ";
		$this->searchMethod == 'any' ? ($pString .= " CHECKED>") : ($pString .= ">");
		$pString .= "OR";
		$pString .= "</DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		$pString .= "<P ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"search\"></FORM>";
		return $pString;
	}
// recall stored session
	function readSession($initType)
	{
// Groups and keywords are a comma-separated list of IDs - the first or which (or even only one) 
// may be '0' representing 'Select All'
		if($initType == 1)
		{
			if($this->session->getVar('searchGroup'))
				$this->searchGroup = explode(',', $this->session->getVar('searchGroup'));
			if($this->session->getVar('searchKeyword'))
				$this->searchKeyword = explode(',', $this->session->getVar('searchKeyword'));
			if($this->session->getVar('searchGroupMethod') == 'AND')
				$this->searchGroupMethod = 'AND';
			else
// Default
				$this->searchGroupMethod = 'OR';
			if($this->session->getVar('searchKeywordMethod') == 'AND')
				$this->searchKeywordMethod = 'AND';
			else
// Default
				$this->searchKeywordMethod = 'OR';
		}
		else
		{
			foreach($this->params1 as $param)
			{
				($this->$param = $this->session->getVar($param)) == 'CHECKED' ?
					TRUE : $this->$param = '';
			}
			foreach($this->params2 as $param)
			{
				($this->$param = $this->session->getVar($param)) == 'CHECKED' ?
					TRUE : $this->$param = '';
				if($param == 'searchMethod')
				{
					($this->searchMethod = $this->session->getVar('searchMethod')) ?
						TRUE : $this->searchMethod = 'phrase';
					continue;
				}
				($this->$param = $this->session->getVar($param)) == 'CHECKED' ?
					TRUE : $this->$param = '';
			}
			($this->searchTitle = $this->session->getVar('searchTitle')) == 'CHECKED' ?
				TRUE : $this->searchTitle = '';
			($this->searchTerm = $this->session->getVar('searchTerm')) ?
				TRUE : $this->searchTerm = '';
			($this->searchPartial = $this->session->getVar('searchPartial')) == 'CHECKED' ?
				TRUE : $this->searchPartial = '';
			($this->searchMethod = $this->session->getVar('searchMethod')) ?
				TRUE : $this->searchMethod = 'phrase';
		}
	}
// search the database
	function searchBegin()
	{
		$this->checkInput();
		$this->writeSession();
		$this->createTableString();
		return $this->parseSearchMethod();
	}
// create table string ready for SQL select statement
	function createTableString()
	{
		$tables = array();
		$quotesTable = FALSE;
		foreach($this->param2Input as $param)
		{
// title comes from resources table
			if($param == 'searchTitle')
				continue;
// quotes and comments on quotes come from the same table:
			if($param == 'searchQuote')
				$quotesTable = TRUE;
			if(($param == 'searchQComment') && $quotesTable)
				continue;
			else if($param == 'searchQComment')
				$quotesTable = TRUE;
			if($param == 'searchNote')
				$id = '.id';
			else
				$id = '.resource_id';
			$table = 'LEFT JOIN ' . $this->tables2[$param] . ' AS ' . $this->tableStmt[$param] . 
				' ON resource.id=' . $this->tableStmt[$param] . $id;
			array_push($tables, $table);
		}
// groups and keywords
		if($this->session->getVar('searchGroup'))
		{
			$this->searchGroup = explode(',', $this->session->getVar('searchGroup'));
			if($this->searchGroup[0])
				array_push($tables, 'LEFT JOIN resource_groups  AS g ON resource.id=g.id');
			else
				$this->searchGroup = FALSE;
			$this->searchGroupMethod = $this->session->getVar('searchGroupMethod');
		}
		else
		{
			$this->searchGroup = FALSE;
		}
		if($this->session->getVar('searchKeyword'))
		{
			$this->searchKeyword = explode(',', $this->session->getVar('searchKeyword'));
			if($this->searchKeyword[0])
				array_push($tables, 'LEFT JOIN resource_keywords  AS k ON resource.id=k.id');
			else
				$this->searchKeyword = FALSE;
			$this->searchKeywordMethod = $this->session->getVar('searchKeywordMethod');
		}
		else
		{
			$this->searchKeyword = FALSE;
		}
		$this->tables = implode(' ', $tables);
	}
// check we have required input
	function checkInput()
	{
// There may be only one group and keywords may not be set in the database - so these are optional.
		$foundParam1 = FALSE;
		$foundParam2 = FALSE;
		$foundParam3 = FALSE;
		$foundParam4 = FALSE;
		$foundTerm = FALSE;
		$this->param1Input = array();
		$this->param2Input = array();
		$this->param3Input = array();
		foreach($this->params1 as $param)
		{
			if(isset($this->vars[$param]))
			{
				$foundParam1 = TRUE;
				array_push($this->param1Input, $param);
			}
			else
				$this->session->setVar($param, 'NULL');
		}
		foreach($this->params2 as $param)
		{
			if(isset($this->vars[$param]))
			{
				$foundParam2 = TRUE;
				array_push($this->param2Input, $param);
			}
			else
				$this->session->setVar($param, 'NULL');
		}
		if(isset($this->vars['searchGroupMethod']))
			$foundParam3 = TRUE;
		if(isset($this->vars['searchKeywordMethod']))
			$foundParam4 = TRUE;
		if(isset($this->vars['searchTerm']) && trim($this->vars['searchTerm']))
			$foundTerm = TRUE;
		if(!$foundParam4 || !$foundTerm)
			$this->auth->gracefulExit(TRUE, "Missing search parameter.");
// following checkboxes not checked are equivalent to searching on all
		if(!$foundParam1)
			$this->param1Input = $this->params1;
		if(!$foundParam2)
			$this->param2Input = $this->params2;
	}
// write search parameters to session
	function writeSession()
	{
// Type 1 params:
// groups
		if(isset($this->vars['searchGroup']) && $this->vars['searchGroup'])
			$this->session->setVar('searchGroup', trim(implode(',', $this->vars['searchGroup'])));
		if(!isset($this->vars['searchGroup']))
			$this->session->setVar('searchGroup', 0);
// keywords
		if(isset($this->vars['searchKeyword']) && $this->vars['searchKeyword'])
			$this->session->setVar('searchKeyword', trim(implode(',', $this->vars['searchKeyword'])));
		if(!isset($this->vars['searchKeyword']))
			$this->session->setVar('searchKeyword', 0);
		foreach($this->param1Input as $param)
			$this->session->setVar($param, 'CHECKED');
		foreach($this->param2Input as $param)
			$this->session->setVar($param, 'CHECKED');
		foreach($this->params4 as $param)
		{
			isset($this->vars[$param]) ?
				$this->session->setVar($param, $this->vars[$param]) : 
				$this->session->setVar($param, 'OR');
		}
		if(isset($this->vars['searchTerm']) && trim($this->vars['searchTerm']))
			$this->session->setVar('searchTerm', trim($this->vars['searchTerm']));
		isset($this->vars['searchPartial']) ?
			$this->session->setVar('searchPartial', 'CHECKED') : 
			$this->session->setVar('searchPartial', 'NULL');
		if(isset($this->vars['searchMethod']))
			$this->session->setVar('searchMethod', $this->vars['searchMethod']);
	}
// basic formatting of search statement
	function makeSearchStmtBasic()
	{
		$conditionArray = array();
		if($this->session->getVar('searchTitle') != 'NULL' )
		{
			$string = $this->makeCondition(3, 'searchTitle', 'title');
			array_push($conditionArray, "$string");
		}
		if($this->session->getVar('searchQuote') != 'NULL')
		{
			$string = $this->makeCondition(4, 'searchQuote', 'quote');
			array_push($conditionArray, "$string");
		}
		if($this->session->getVar('searchQComment') != 'NULL')
		{
			$string = $this->makeCondition(5, 'searchQComment', 'comment');
			array_push($conditionArray, "$string");
		}
		if($this->session->getVar('searchNote') != 'NULL')
		{
			$string = $this->makeCondition(1, 'searchNote', 'notes');
			array_push($conditionArray, "$string");
		}
		if($this->session->getVar('searchMusing') != 'NULL')
		{
			$string = $this->makeCondition(2, 'searchMusing', 'musing');
			array_push($conditionArray, "$string");
		}
		return $conditionArray;
	}
// Make search statement for 'any' and 'phrase' type searches
	function makeSearchStmt()
	{
//  Add the resource type one of at least which must always be chosen.
		$typeArray = array();
		foreach($this->param1Input as $param)
		{
			if(array_key_exists($param, $this->types))
				array_push($typeArray, "resource.type='" . $this->types[$param] . "'");
		}
		$types = implode(' OR ', $typeArray);
// Add the groups type of which at least one must be chosen.  If $this->searchGroup is not set or 
// [0] is 0 it means there is only one group so ignore this setting.
		$groupArray = array();
		$groups = '';
		if($this->searchGroup)
		{
			foreach($this->searchGroup as $value)
			{
				array_push($groupArray, "FIND_IN_SET($value, g.groups)");
			}
			$groups = 'AND (' . implode(' ' . $this->searchGroupMethod . ' ', $groupArray) . ')';
		}
// Add the keywords type which is optional although if nothing is select, 'select all' is the default.
// If $this->searchGroup is not set or [0] is 0 it means there is only one group so ignore this setting.
		$keywordArray = array();
		$keywords = '';
		if($this->searchKeyword)
		{
			foreach($this->searchKeyword as $value)
			{
				array_push($keywordArray, "FIND_IN_SET($value, k.keywords)");
			}
			$keywords = 'AND (' . implode(' ' . $this->searchKeywordMethod . ' ', $keywordArray) . ')';
		}
		return ") AND (" . $types . ") " . $groups . " " . $keywords;
	}
// $string to be searched as complete phrase
	function searchPhrase()
	{
		if(!$this->string = $this->parseSearchString(trim($this->vars['searchTerm'])))
			return;
		$condition = implode($this->conditionTableJoin, $this->makeSearchStmtBasic());
		$condition .= $this->makeSearchStmt();
	        $condition .= " ORDER BY author1_surname";
		$condition = $this->condition . " WHERE (" . $condition;
		$tables = "resource " . $this->tables;
	        $stmt = "DISTINCT " . $this->stmt;
		$sql = $this->db->select($tables, $stmt, $condition);
		$this->sth = $this->db->query($sql);
		return "<DIV class=\"searchterm\">\"" . $this->vars['searchTerm'] . "\"</DIV>";
	}
// Search on any of $string's words ($word1 OR $word2 OR $word3 etc.)
	function searchAny()
	{
		$strArray = explode(" ", trim($this->vars['searchTerm']));
		$allIds = array();
		$display = array();
		foreach($strArray AS $string)
		{
			if(!$this->string = $this->parseSearchString($string))
				continue;
			$display[] = $this->string;
			$conditionArray[] = implode($this->conditionTableJoin, $this->makeSearchStmtBasic());
		}
		$condition = implode(' OR ', $conditionArray);
		$condition .= $this->makeSearchStmt();
	        $condition .= " ORDER BY author1_surname";
		$condition = $this->condition . " WHERE (" . $condition;
		$tables = "resource " . $this->tables;
	        $stmt = "DISTINCT " . $this->stmt;
		$sql = $this->db->select($tables, $stmt, $condition);
		$this->sth = $this->db->query($sql);
		return "<DIV class=\"searchterm\">" . implode(' OR ', $display) . "</DIV>";
	}
// All words in $this->vars['searchTerm'] must appear somewhere in returned posts - (words in any order).
	function searchAll()
	{
		$strArray = explode(" ", trim($this->vars['searchTerm']));
		$allIds = array();
		$display = array();
		$firstTime = TRUE;
		foreach($strArray AS $string)
		{
			if(!$this->string = $this->parseSearchString($string))
				continue;
			$display[] = $this->string;
			$conditionArray[] = implode($this->conditionTableJoin, $this->makeSearchStmtBasic());
		}
		$condition = "(" . implode(') AND (', $conditionArray) . ")";
		$condition .= $this->makeSearchStmt();
	        $condition .= " ORDER BY author1_surname";
		$condition = $this->condition . " WHERE (" . $condition;
		$tables = "resource " . $this->tables;
	        $stmt = "DISTINCT " . $this->stmt;
		$sql = $this->db->select($tables, $stmt, $condition);
		$this->sth = $this->db->query($sql);
		return "<DIV class=\"searchterm\">" . implode(' AND ', $display) . "</DIV>";
	}
// Make column part of SQL condition
	function makeCondition($method, $type = FALSE, $column = FALSE)
	{
		$array = array();
// partial or complete word searching?
		$this->session->getVar('searchPartial') == 'CHECKED' ? 
			$search = " LIKE '%$this->string%'" : 
			$search = " REGEXP '[[:<:]]" . $this->string . "[[:>:]]'";
		if($method == 1)
		{
			$string = $this->tableStmt['searchNote'] . ".$column" . "$search";
			array_push($array, $string);
		}
		else if($method == 2)
		{
			$string = $this->tableStmt['searchMusing'] . ".$column" . "$search";
			array_push($array, $string);
		}
// 3 is for titles
		else if($method == 3)
		{
			$string = "resource.title $search";
			array_push($array, $string);
		}
// Quotes
		if($method == 4)
		{
			$string = $this->tableStmt['searchQuote'] . ".$column" . "$search";
			array_push($array, $string);
		}
		if($method == 5)
		{
			$string = $this->tableStmt['searchQComment'] . ".$column" . "$search";
			array_push($array, $string);
		}
		return implode($this->conditionTableJoin, $array);
	}
// Parse search string
	function parseSearchString($input)
	{
// Trim whitespace
		$string = trim($input);
// add escapes
		return mysql_escape_string($string);
	}
// Parse on search method.
// conditionJoin == for searching on multiple search words.
// conditionTableJoin is for searching over multiple tables (usually 'OR').
	function parseSearchMethod()
	{
		$pString = "<DIV CLASS=\"intro\" STYLE=\"float : left\"><B>Search:</B>&nbsp;&nbsp;</DIV>";
		$this->conditionTableJoin = ' OR ';
// $string to be searched as complete phrase
		if($this->vars['searchMethod'] == "phrase")
			$pString .= $this->searchPhrase();
// All words in $string must appear in returned posts - (words in any order)
		else if($this->vars['searchMethod'] == "all")
			$pString .= $this->searchAll();
// Search on any of $string's words
		else if($this->vars['searchMethod'] == "any")
			$pString .= $this->searchAny();
		else
			$this->auth->gracefulExit(TRUE, "Invalid search method.");
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		if(!$count = $this->db->numRows($this->sth))
		{
			global $PHP_SELF;
			$pString .= "No results from your search.";
			$pString .= "<DIV class=\"back\"><A HREF=\"" . $PHP_SELF . 
				"?action=searchInit\">" . "Refine Your Search</A></DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
			return $pString;
		}
		$pString .= $this->displaySearchResults($count);
		return $pString;
	}
// Display the search results
	function displaySearchResults($count)
	{
// Simply display the resource details with a view full details link
		global $PHP_SELF;
		include_once("classes/STYLE.php");
		$style = new STYLE($this->db);
		include_once("classes/DISPLAY.php");
		$count == 1 ? $resource = 'resource' : $resource = 'resources';
		$pString = "<P>$count $resource found matching your search ('V' opens in a new browser window):<P>";
		$index = 0;
		while($row = $this->db->fetchAssoc($this->sth))
		{
			$pString .= DISPLAY::displayResource($row, $index, $row['type']);
			$index++;
		}
		$pString .= "<DIV class=\"back\"><A HREF=\"" . $PHP_SELF . "?action=searchInit\">" . 
				"Refine Your Search</A></DIV>";
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		return $pString;
	}
}
?>
