<?php
/*****
*	STYLE class.
*	requires style.inc
*****/
class STYLE
{
// Constructor
	function STYLE($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		include_once("classes/CONFIG.php");
		$this->config = new CONFIG();
	}
// import default style
	function getStyle($type, $reprint, $noAuthor, $multipleEditors, $pubLoc, $multiplePages, 
		$journalNumber, $date_accessed)
	{
		$style = FALSE;
// N.B. Not include_once()!!!!!
		include("styles/style.inc");
// style set in session?
		$this->session->getVar('style') ? $style = $this->session->getVar('style') : FALSE;
		$this->session->getVar('styleMedium') ? 
			$this->medium = $this->session->getVar('styleMedium') : $medium = 'HTML';
// if not, get default style from style.inc
		if(!$style)
		{
			if(!isset($WIKINDX_STYLE_DEFAULT) || !$WIKINDX_STYLE_DEFAULT)
				$style = 'MHRA';
			else
				$style = $WIKINDX_STYLE_DEFAULT;
			$this->medium = $WIKINDX_STYLE_FORMAT_HTML;
		}
		else
		{
			$this->medium = $WIKINDX_STYLE_FORMAT . '_' . $medium;
		}
		include_once("styles/$style.php");
		$this->style = new $style($type);
		$this->style->base($reprint, $noAuthor, $multipleEditors, $pubLoc, $multiplePages, 
			$journalNumber, $date_accessed);
	}
/* Begin formatting resource according to style.
*	All bibliographic entries are comprised of items such as author(s), publisher, publication year etc..
*	Each item can have any of the following associated with it and that affect the visual display of the entry:
*
*	DISPLAY - list of potential items that each style permits to be displayed in the entry (TRUE/FALSE)
*	ORDER - the order each item is printed in the entry.
*	FORMAT (italics, bold, brackets etc.) - FALSE is plain text display.
*	PREPUNCTUATION - any punctuation that comes BEFORE the item (including spaces).  FALSE is no punctuation.
*	POSTPUNCTUATION - any punctuation that comes AFTER the item (including spaces).  FALSE is no punctuation.
*	MISSING - what is printed when an entry is missing.
*/
// $medium is either html (display on web browser) or extract (for external display, cut 'n' pasting etc.) 
// and relates to $this->style['format'] array.
	function styleFormat($array, $medium = '')
	{
// stripslashes from database storage
		foreach($array as $key => $value)
			$row[$key] = stripslashes($value);
// import and configure styles - check if no author and this resource must be categorized by editor instead.
// If no author, editor has already been placed in $array['surname'], firstname and initials fields by SQL SELECT.
		if($row['author1'])
			$noAuthor = FALSE;
		else
			$noAuthor = TRUE;
		$reprint = FALSE;
		$pubLoc = FALSE;
		$multipleEditors = FALSE;
		$multiplePages = FALSE;
		$date_accessed = FALSE;
		$journalNumber = FALSE;
		if($row['publisher'])
			$pubLoc = TRUE;
		if($row['journal_number'])
			$journalNumber = TRUE;
		if($row['editor1'] && ($row['editor2'] || $row['ed_et_al']))
			$multipleEditors = TRUE;
		if($row['page_end'])
			$multiplePages = TRUE;
		if($row['date_accessed'])
			$date_accessed = $row['date_accessed'];
		if($row['reprint_year'])
			$reprint = TRUE;
		$this->getStyle($row['type'], $reprint, $noAuthor, $multipleEditors, $pubLoc, $multiplePages, 
			$journalNumber, $date_accessed);
// Are we overwriting the default HTML medium?
		$medium ? $this->medium = $medium : FALSE;
// add title
		$row['title'] = $this->style->baseArray['pre']['title'] . $row['title'] .
			$this->style->baseArray['post']['title'];
/*	
*	Author, editor, publisher and journal title details are stored in separate tables accessed via ID numbers
*	from the resource table.
*	First task is add to $row (as per the style) details as above and remove disallowed values 
*	from $row.
*/
		foreach($row as $key => $value)
			if(array_key_exists($key, $this->style->baseArray['order']) 
				&& $this->style->baseArray['order'])
					$current[$key] = stripslashes($value);
//print_r($row); print "<P>";
		if($row['author1'])
		{
			$nameArray = array('author1', 'author2', 'author3', 'author4', 'author5', 'author6');
			$current['author'] = $this->getName($row, $nameArray, 'et_al');
		}
//print_r($current); print "<P>";
		if(($row['type'] == 'book') || ($row['type'] == 'book_article'))
		{
			if($row['editor1'])
			{
				$nameArray = array('editor1', 'editor2', 'editor3', 'editor4', 'editor5', 'editor6');
				$current['editor'] = $this->style->baseArray['pre']['editor'] . 
					$this->getName($row, $nameArray, 'ed_et_al') . 
					$this->style->baseArray['post']['editor'];
			}
//print_r($current); print "<P>";
			if($row['translator1'])
			{
				$nameArray = array('translator1', 'translator2', 'translator3',);
				$current['translator'] = $this->style->baseArray['pre']['translator'] . 
					$this->getName($row, $nameArray, 'trans_et_al') . 
					$this->style->baseArray['post']['translator'];
			}
			if($row['reviser1'])
			{
				$nameArray = array('reviser1', 'reviser2', 'reviser3',);
				$current['reviser'] = $this->style->baseArray['pre']['reviser'] . 
					$this->getName($row, $nameArray, 'rev_et_al') . 
					$this->style->baseArray['post']['reviser'];
			}
			$current['publisher'] = $this->getPublisher($row);
			unset($current['year']);
			if($row['volumes'])
				$current['volume'] = $this->getVolume($row, $current);
			$current['edition'] = $this->getEdition($current);
			if($row['series_title'])
				$current['series'] = $this->getSeries($row);
			if($row['book_title'])
				$current['book_title'] = $this->style->baseArray['pre']['book_title'] . 
					$row['book_title'] . 
					$this->style->baseArray['post']['book_title'];
		}
		if($row['page_start'])
			$pages = $this->getPages($row);
		else
			$pages = '';
		if(($row['type'] == 'journal_article') || ($row['type'] == 'web_article'))
		{
// we do not display the journal volume and number if no journal_title is given (in the case of web articles).
			if($row['journal_title'])
				$current['journal_issue'] = $this->getJournal($row, $current);
			unset($current['volume']);
			if($row['year'])
				$current['year'] = $this->style->baseArray['pre']['year'] . 
					$row['year'] . 
					$this->style->baseArray['post']['year'];
			else
				$current['year'] = $this->style->baseArray['pre']['year'] . 
					$this->style->missing['year'] . 
					$this->style->baseArray['post']['year'];
		}
		if($row['type'] == 'web_article')
		{
			$current['web_address'] = $this->style->baseArray['pre']['web_address'] . 
				$row['web_address'] . $this->style->baseArray['post']['web_address'];
			$current['web_address'] = "<A CLASS=\"linkNone\" HREF=\"" . $current['web_address'] . 
				"\" TARGET=\"_blank\">" . $current['web_address'] . "</A>";
			if($row['date_accessed'])
				$current['date_accessed'] = $this->style->baseArray['pre']['date_accessed'] . 
					$this->style->dateAccessed . 
					$this->style->baseArray['post']['date_accessed'];
			$current['web_pages'] = $pages;
		}
		else
		{
			$current['pages'] = $pages;
		}
// remove empty array values
		foreach($current as $key => $value)
			if(!$value)
				unset($current[$key]);
//print "EMPTY: " ; print_r($current); print "<P>";
// Next, add font formatting etc. according to destination medium as defined by $medium 
// (web/html is default medium).
		foreach($current as $key => $value)
		{
			if(!$this->style->baseArray['order'][$key])
				continue;
			$current[$key] = 
				$this->medium[$this->style->baseArray['order'][$key]][0] . $value . 
				$this->medium[$this->style->baseArray['order'][$key]][1];
		}
// We now have allowed items in all details.
// Next, place in correct order.
		foreach($this->style->baseArray['order'] AS $key => $value)
			if(array_key_exists($key, $current))
				$order[$key] = $current[$key];
//print "ORDER: " ; print_r($order); print "<P>";
// We should now have an ordered array whose elements are the main building blocks for the final string e.g.
// author, title, editor, edition, publisher etc. etc. etc.
// It remains solely to punctuate between those strings and then collapse the array into one string and return 
// it for printing to the browser.
		foreach($order as $key => $value)
			$order[$key] = $this->style->stringPunc[$key] . $value;
//print "PUNCTUATE: " ; print_r($order); print "<P>";
		return implode('', $order) . "<P>";
	}
// Extract names from writer table.
//  All names must have a surname and either or both initials and firstname.
// If type = 'book', author1 may not be set and surname, firstname etc. in $row[] represent editor1 instead.
	function getName($row, $nameArray, $etAl)
	{
		$newArray = array();
		foreach($nameArray as $name)
		{
// ensure $array and $order are reset each loop
			$array = array();
			$order = array();
			if($row[$name])
			{
				if(($name == 'editor1') && !$row['author1'])
				{
					$array['editor1_surname'] = $row['author1_surname'];
					$array['editor1_firstname'] = $row['author1_firstname'];
					$array['editor1_initials'] = $row['author1_initials'];
				}
				else
				{
					$array = $this->pullName($row, $name);
				}
				if(array_key_exists($name . '_initials', $array) && $array[$name . '_initials'])
					$array[$name . '_initials'] = 
					$this->formatInitials($array[$name . '_initials']);
// Add (pre)punctuation between parts of name.
// As $this->style->$name is a reference, need to copy it before we can dereference it
				$punc = $this->style->$name;
				foreach($array as $key => $value)
				{
					if($value)
					{
						if(($key == $name . '_initials') && !$array[$name . '_firstname'])
							$array[$key] = $punc['preInitials'] . $value;
						else
							$array[$key] = $punc[$key] . $value;
					}
				}
			}
// order the name
			foreach($this->style->$name as $key => $value)
			{
				if(array_key_exists($key, $array))
				{
					$order[$key] = $array[$key];
				}
			}
			if(!sizeof($order)) continue;
// collapse $order to string and place in newArray
			$newArray[] = implode('', $order);
		}
		return $this->formatNames($row, $newArray, $etAl);
	}
// Extract names from row.
//  All names must have a surname and either or both initials and firstname.
	function pullName($row, $name)
	{
		$fn = $name . '_firstname';
		$sn = $name . '_surname';
		$i = $name . '_initials';
		return array(
				$fn	=>	$row[$fn],
				$sn	=>	$row[$sn],
				$i	=>	$row[$i],
			);
	}
// format the names array
	function formatNames($row, $newArray, $etAl)
	{
		$index = 0;
		$array = array();
// punctuate between authors and add any et_al or ed_et_al
		if(sizeof($newArray) == 1)
		{
			if(($etAl == 'NULL') || !$row[$etAl])
				return $newArray[0];
			return $newArray[0] . $this->style->$etAl;
		}
		else if(($size = sizeof($newArray)) == 2)
		{
			if($this->style->maxWritersLimit < $size)
			{
				while($index < $this->style->maxWriters)
					$array[] = $newArray[$index++];
				return implode($this->style->listDelimiter, $array) . $this->style->$etAl;
			}
			if(($etAl == 'NULL') || !$row[$etAl])
				return $newArray[0] . $this->style->listDelimiterOverride . $newArray[1];
			return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->$etAl;
		}
		else if(($size = sizeof($newArray)) == 3)
		{
			if($this->style->maxWritersLimit < $size)
			{
				while($index < $this->style->maxWriters)
					$array[] = $newArray[$index++];
				return implode($this->style->listDelimiter, $array) . $this->style->$etAl;
			}
			if(($etAl == 'NULL') || !$row[$etAl])
				return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiterOverride . $newArray[2];
			return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . 
					$newArray[2] . $this->style->$etAl;
		}
		else if(($size = sizeof($newArray)) == 4)
		{
			if($this->style->maxWritersLimit < $size)
			{
				while($index < $this->style->maxWriters)
					$array[] = $newArray[$index++];
				return implode($this->style->listDelimiter, $array) . $this->style->$etAl;
			}
			if(($etAl == 'NULL') || !$row[$etAl])
				return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . $newArray[2] . 
					$this->style->listDelimiterOverride . $newArray[3];
			return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . 
					$newArray[2] . $this->style->listDelimiter . 
					$newArray[3] . $this->style->$etAl;
		}
		else if(($size = sizeof($newArray)) == 5)
		{
			if($this->style->maxWritersLimit < $size)
			{
				while($index < $this->style->maxWriters)
					$array[] = $newArray[$index++];
				return implode($this->style->listDelimiter, $array) . $this->style->$etAl;
			}
			if(($etAl == 'NULL') || !$row[$etAl])
				return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . $newArray[2] . 
					$this->style->listDelimiter . $newArray[3] . 
					$this->style->listDelimiterOverride . $newArray[4];
			return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . 
					$newArray[2] . $this->style->listDelimiter . 
					$newArray[3] . $this->style->listDelimiter . 
					$newArray[4] . $this->style->$etAl;
		}
		else if(($size = sizeof($newArray)) == 6)
		{
			if($this->style->maxWritersLimit < $size)
			{
				while($index < $this->style->maxWriters)
					$array[] = $newArray[$index++];
				return implode($this->style->listDelimiter, $array) . $this->style->$etAl;
			}
			if(($etAl == 'NULL') || !$row[$etAl])
				return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . $newArray[2] . 
					$this->style->listDelimiter . $newArray[3] . 
					$this->style->listDelimiter . $newArray[4] . 
					$this->style->listDelimiterOverride . $newArray[5];
			return $newArray[0] . $this->style->listDelimiter . 
					$newArray[1] . $this->style->listDelimiter . 
					$newArray[2] . $this->style->listDelimiter . 
					$newArray[3] . $this->style->listDelimiter . 
					$newArray[4] . $this->style->listDelimiter . 
					$newArray[5] . $this->style->$etAl;
		}
	}
// Extract and order publisher details from publisher table.  If details are missing, use $this->style->missing.
	function getPublisher($row)
	{
		foreach($this->style->publisher as $key => $value)
		{
			if(!$row[$key])
				$order[$key] = $this->style->missing[$key];
			else
				$order[$key] = $row[$key];
		}
// is this a reprint?
		if($row['reprint_year'])
			$order['reprint_year'] = $row['reprint_year'];
		$this->punctuate($order);
		return implode('', $order);
	}
// pre and post punctuate
	function punctuate(&$order)
	{
		foreach($order as $key => $value)
		{
			if(array_key_exists($key, $this->style->baseArray['pre']))
				$value = $this->style->baseArray['pre'][$key] . $value;
			if(array_key_exists($key, $this->style->baseArray['post']))
				$value = $value . $this->style->baseArray['post'][$key];
			$order[$key] = $value;
		}
	}
// Format edition (cardinal -> ordinal)
	function getEdition($current)
	{
		if(array_key_exists('edition', $current) && $current['edition'])
// merge in this order so $array['publisher'] overwrites $current['publisher']
			return $this->style->baseArray['pre']['edition'] . 
				$current['edition'] . $this->style->ordinal[$current['edition']] . 
				$this->style->baseArray['post']['edition'];
	}
// Format volume information - DB has ALL 3 of no. volumes, volume no. and volume publication year.
	function getVolume($row, &$current)
	{
// 'volumes' is dealt with separately as, in MHRA style, it is separated from specific volume details.
		$current['volumes'] = $this->style->baseArray['pre']['volumes'] . $row['volumes'] . 
			$this->style->baseArray['post']['volumes'];
		foreach($this->style->volume as $key => $value)
			$order[$key] = $row[$key];
		$order['volume_number'] = $this->style->volumeNumberConvert[$order['volume_number']];
		$this->punctuate($order);
		return implode('', $order);
	}
// Format series information.
	function getSeries($row)
	{
		foreach($this->style->series as $key => $value)
			$order[$key] = $row[$key];
		$this->punctuate($order);
		return implode('', $order);
	}
// get pages (possible to have only page_start)
	function getPages($row)
	{
		foreach($this->style->pages as $key => $value)
			$order[$key] = $row[$key];
		$this->punctuate($order);
		return implode('', $order);
	}
// get journal title
	function getJournal($row)
	{
		foreach($this->style->journal_issue as $key => $value)
			if($row[$key])
				$order[$key] = $row[$key];
		if(isset($order))
		{
			$this->punctuate($order);
			return implode('', $order);
		}
	}
// In the database, initials are stored uppercase, unpunctuated and space-delimited.
// This function will delimit them according to the chosen style.
	function formatInitials($initials)
	{
		return implode($this->style->initialsDelimiter, explode(' ', $initials)) . 
			$this->style->postInitials;
	}
}
?>
