<?php
/*****
*	Gateway to the system.  Here, the form variable 'action' is parsed to 
*	determine the course of
*	action.
*	All actions and requests pass via this gateway.
*****/
// remove this before production
error_reporting(E_ALL);
ob_start();
/*****
*	start the PHP session
*****/
session_start();

$WIKINDX_DB_QUERIES = 0;
include_once("config.inc");
include_once($WIKINDX_PATH_TO_CLASSES . "SCRIPTTIME.php");
$timer = new SCRIPTTIME();
$WIKINDX_START_TIME = $timer->start_time();
include_once($WIKINDX_PATH_TO_CLASSES . "DB.php");
include_once($WIKINDX_PATH_TO_CLASSES . "AUTH.php");
include_once($WIKINDX_PATH_TO_CLASSES . "DISPLAY.php");
/*****
*	Make sure we get HTTP VARS in whatever format they come in
*****/
$HTTP_POST_VARS ? $vars = $HTTP_POST_VARS : $vars = $HTTP_GET_VARS;
/*****
*	In case authentication is required for WRITE we initialise $logon.
*	$logon needs to be TRUE before we can proceed to WIKINDX.
*****/
$WIKINDX_AUTH_WRITE ?
	$logon = FALSE :
	$logon = TRUE;
/*****
*	Since 99% of actions require the database to be opened, we open it here.
*****/
	$db = new DB();
/*****
*	Create the $auth object which handles logins and graceful exiting and pass the 
*	db handle to it.
*****/
	$auth = new AUTH($db);
	include_once($WIKINDX_PATH_TO_CLASSES . "SESSION.php");
	$session = new SESSION();
//  At this point, logon will only be TRUE is WRITE authorization is NOT required.
// i.e. we are cleared to proceed into the WIKINDX.  Session variable 'write' is set to FALSE to indicate read-only and 
// to TRUE to indicate READ/WRITE.
	if($logon)
	{
		if(!$session->setVar('write', TRUE))
			$auth->gracefulExit(FALSE, 'Unable to write to session.');
	}
/*****
*	Parse 'action' variable.  If not set and !$logon, we print out the empty logon form and 
*	exit immediately
*****/
	if(!isset($vars["action"]))
	{
		if($logon)
			$display = new DISPLAY($db, $auth, $vars, 'front');
		else
			$auth->initLogon();
		$auth->gracefulExit(FALSE);
	}
/*****
*	If needed, first pass through authentication.
*****/
	if(($vars["action"] == 'logon') && isset($vars["password"]) && isset($vars["username"]))
	{
/*****
*	Initial  log on.  Need to compare supplied username/password with those in 
*	config.inc. $auth->logon dies if bad comparison.
*****/
		$auth->logon($vars["username"], $vars["password"]);
		$logon = TRUE;
		$display = new DISPLAY($db, $auth, $vars, 'front');
		$auth->gracefulExit(FALSE);
	}
/*****
*	From this point on, if $AUTH_READ is TRUE, we always need to validate a returning user by checking
*	if a session exists. If validation is successful, display the HTML <head>.
*	If $AUTH_READ is FALSE, $logon has already been set to TRUE (above) and we require no
*	authentication anyway.
*****/
	if(!$logon)
	{
		if(!$auth->validateUser())
		{
			$string = "Unable to validate you. Ensure that you are attempting to logon " . 
				"<A HREF = \"index.php\">here</A>";
			$auth->gracefulExit(FALSE, $string);
		}
	}
// From this point on, user is cleared to proceed
	$display = new DISPLAY($db, $auth, $vars, $vars['action']);
	$auth->gracefulExit(FALSE);
?>
