<?php
//////////////////// MHRA academic formatting
/*****
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
*****/
/*****
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
*****/
/*****
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
*****/
/*****
*
*	STYLE DEFINITIONS
*	Don't mess around with these unless you know what you're doing!
*	Don't mess around with these unless you know what you're doing!
*	Don't mess around with these unless you know what you're doing!
*
*	All bibliographic entries are comprised of items such as author(s), publisher, publication year etc..
*	Each item can have any of the following associated with it and that affect the visual display of the entry:
*
*	DISPLAY - list of potential items that each style permits to be displayed in the entry (TRUE/FALSE)
*	ORDER - the order each item is printed in the entry.
*	FORMAT (italics, bold, brackets etc.) - FALSE is plain text display.
*	PREPUNCTUATION - any punctuation that comes BEFORE the item (including spaces).  FALSE is no punctuation.
*	POSTPUNCTUATION - any punctuation that comes AFTER the item (including spaces).  FALSE is no punctuation.
*
*	Additionally, MISSING is what should be printed when an entry is missing.
*
*	Each item in the entry should be named as per the SQL table columns.
*
*	Each style is a multi-dimensional array containing FORMAT, ORDER and PUNCTUATION
*
*****/

/*********************************************************************************************/
class MHRA
{
// CONSTRUCTOR
	function MHRA($type)
	{
		$this->type = $type;
	}
// create baseArray
	function base($reprint, $noAuthor, $multipleEditors, $pubLoc, $multiplePages, 
		$journalNumber, $date_accessed)
	{
		$this->baseArray = array(
// order of display and font formatting for all possible elements.
// FALSE indicates normal font - other options from style.inc:$WIKINDX_STYLE_FORMAT_HTML (italics, bold etc.).
// May be overridden by $this->type settings below
				'order' => array(
						'author'		=>	FALSE,
						'title'			=>	'italics',
						'subtitle'		=>	'italics',
						'book_title'		=>	'italics',
						'volumes'		=>	FALSE,
					),
// The following are always printed prior to the item.  If the item happens to be the start of a building block 
// or main string of the final printout you may wish to leave blank and set in $this->stringPunc below.
				'pre' => array(
						'title'			=>	"",
						'subtitle'		=>	"",
						'book_title'		=>	"",
						'journal_title'		=>	"",
						'journal_volume'	=>	"",
						'journal_number'	=>	"",
						'editor'		=>	"ed. by ",
						'reviser'		=>	"rev. by ",
						'translator'		=>	"trans. by ",
						'page_start'		=>	"pp. ",
						'page_end'		=>	"-",
						'publisher_location'	=>	"(",
						'year'			=>	", ",
						'publisher_name'	=>	" ",
						"volumes"		=>	"",
						'volume_year'		=>	" (",
						'reprint_year'		=>	"repr. ",
						'edition'		=>	"",
						'series_number'		=>	", ",
						'web_address'		=>	"",
						'date_accessed'		=>	"[accessed ",
					),
// The following are always printed after the item
				'post' => array(
						'title'			=>	"",
						'subtitle'		=>	"",
						'book_title'		=>	"",
						'journal_title'		=>	", ",
						'journal_volume'	=>	"",
						'journal_number'	=>	"",
						'editor'		=>	"",
						'reviser'		=>	"",
						'translator'		=>	"",
						'page_start'		=>	"",
						'page_end'		=>	"",
						'publisher_location'	=>	":",
						'year'			=>	")",
						'publisher_name'	=>	"",
						"volumes"		=>	" vols",
						'volume_year'		=>	")",
						'reprint_year'		=>	")",
						'edition'		=>	"edn",
						'series_number'		=>	"",
						'web_address'		=>	"",
						'date_accessed'		=>	"]",
					),
				);
		$order2 = array(
					'edition'		=>	FALSE,
					'reviser'		=>	FALSE,
					'translator'		=>	FALSE,
					'series'		=>	FALSE,
					'volumes'		=>	FALSE,
					'publisher'		=>	FALSE,
					'volume'		=>	FALSE,
					'journal_title'		=>	'italics',
					'journal_issue'		=>	FALSE,
					'year'			=>	FALSE,
					'web_address'		=>	'URL',
					'date_accessed'		=>	FALSE,
					'pages'			=>	FALSE,
					'web_pages'		=>	FALSE,
				);
		$editor = array(
					'editor'		=>	FALSE,
				);
// If no author, we must remove author and put the editor(s) for display first.
		if($noAuthor)
		{
			array_shift($this->baseArray['order']);
			$this->baseArray['order'] = $editor + $this->baseArray['order'];
			$this->baseArray['order']['editor'] = FALSE;
			$this->baseArray['order'] += $order2;
		}
		else
		{
			$this->baseArray['order'] = $this->baseArray['order'] + $editor;
			$this->baseArray['order'] += $order2;
		}
// Author ordering and prepunctuation - assume 3 parts to name (see $preInitials below)
		$this->author1 = array(
					'author1_surname'		=>	"",
					'author1_firstname'		=>	", ",
					'author1_initials'		=>	" ",
// If an author has initials but no firstname, what punctuation precedes initials?
					'preInitials'			=>	", ",
				);
		$this->author2 = array(
					'author2_firstname'		=>	" ",
					'author2_initials'		=>	" ",
					'author2_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->author3 = array(
					'author3_firstname'		=>	" ",
					'author3_initials'		=>	" ",
					'author3_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->author4 = array(
					'author4_firstname'		=>	" ",
					'author4_initials'		=>	" ",
					'author4_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->author5 = array(
					'author5_firstname'		=>	" ",
					'author5_initials'		=>	" ",
					'author5_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->author6 = array(
					'author6_firstname'		=>	" ",
					'author6_initials'		=>	" ",
					'author6_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
// Editor ordering and prepunctuation - assume 3 parts to name (see $preInitials below)
		if($noAuthor)
		{
			$this->editor1 = array(
						'editor1_surname'		=>	"",
						'editor1_firstname'		=>	", ",
						'editor1_initials'		=>	" ",
// If an editor has initials but no firstname, what punctuation precedes initials?
						'preInitials'			=>	" ",
					);
		}
		else
		{
			$this->editor1 = array(
						'editor1_firstname'		=>	" ",
						'editor1_initials'		=>	" ",
						'editor1_surname'		=>	" ",
						'preInitials'			=>	"",
						);
		}
		$this->editor2 = array(
					'editor2_firstname'		=>	" ",
					'editor2_initials'		=>	" ",
					'editor2_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->editor3 = array(
					'editor3_firstname'		=>	" ",
					'editor3_initials'		=>	" ",
					'editor3_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->editor4 = array(
					'editor4_firstname'		=>	" ",
					'editor4_initials'		=>	" ",
					'editor4_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->editor5 = array(
					'editor5_firstname'		=>	" ",
					'editor5_initials'		=>	" ",
					'editor5_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
		$this->editor6 = array(
					'editor6_firstname'		=>	" ",
					'editor6_initials'		=>	" ",
					'editor6_surname'		=>	" ",
					'preInitials'			=>	" ",
				);
// publisher string
		$this->publisher = array(
					'publisher_location'	=>	FALSE,
					'publisher_name'	=>	FALSE,
					'year'			=>	FALSE,
				);
// what to print if publisher details are missing
		$this->missing = array(
					'publisher_name'	=>	"[n.pub.]",
					'publisher_location'	=>	"[n.p.]",
					'year'			=>	"[n.d.]",
				);
// Translator ordering
		$this->translator1 = array(
					'translator1_firstname'		=>	"",
					'translator1_initials'		=>	" ",
					'translator1_surname'		=>	" ",
					'preInitials'			=>	"",
				);
// Translator ordering
		$this->translator2 = array(
					'translator2_firstname'		=>	" ",
					'translator2_initials'		=>	" ",
					'translator2_surname'		=>	" ",
					'preInitials'			=>	"",
				);
// Translator ordering
		$this->translator3 = array(
					'translator3_firstname'		=>	" ",
					'translator3_initials'		=>	" ",
					'translator3_surname'		=>	" ",
					'preInitials'			=>	"",
				);
// reviser ordering
		$this->reviser1 = array(
					'reviser1_firstname'		=>	"",
					'reviser1_initials'		=>	" ",
					'reviser1_surname'		=>	" ",
					'preInitials'			=>	"",
				);
// reviser ordering
		$this->reviser2 = array(
					'reviser2_firstname'		=>	" ",
					'reviser2_initials'		=>	" ",
					'reviser2_surname'		=>	" ",
					'preInitials'			=>	"",
				);
// reviser ordering
		$this->reviser3 = array(
					'reviser3_firstname'		=>	" ",
					'reviser3_initials'		=>	" ",
					'reviser3_surname'		=>	" ",
					'preInitials'			=>	"",
				);
// journal issue string
		$this->journal_issue = array(
					'journal_volume'		=>	FALSE,
					'journal_number'		=>	FALSE,
				);
// series string
		$this->series = array(
					'series_title'		=>	FALSE,
					'series_number'		=>	FALSE,
				);
// book/book_article volume string (no. of volumes is a different string)
		$this->volume = array(
					'volume_number'		=>	FALSE,
					'volume_year'		=>	FALSE,
				);
// pages string
		$this->pages = array(
					'page_start'		=>	FALSE,
					'page_end'		=>	FALSE,
				);
// The following are printed prior to each element.  Each string is one of the main building blocks of the 
// final result (e.g. 'author', may itself be composed of several author's names, 'publisher' of several items 
// of publishing details).   Here, we punctuate BEFORE each string (likely to be just commas and or spaces).
// Building blocks from (author, editor, title, reviser, translator, publisher, edition, volumes, series, volume, 
// journal or web).
		$this->stringPunc = array(
					'author'		=>	"",
					'title'			=>	", ",
					'subtitle'		=>	": ",
					'book_title'		=>	", in ",
					'editor'		=>	", ",
					'translator'		=>	", ",
					'reviser'		=>	", ",
					'edition'		=>	", ",
					'publisher'		=>	" ",
					'volumes'		=>	", ",
					'volume'		=>	", ",
					'series'		=>	", ",
					'journal_title'		=>	", ",
					'journal_issue'		=>	" ",
					'year'			=>	" ",
					'web_address'		=>	" ",
					'date_accessed'		=>	" ",
					'pages'			=>	", ",
					'web_pages'		=>	" ",
				);
// The following replace the database value
		if($journalNumber)
			$this->baseArray['post']['journal_volume'] = ".";
		if(!$multiplePages)
		{
			$this->baseArray['pre']['page_start'] = "p. ";
			$this->baseArray['pre']['page_end'] = "";
		}
		if($this->type == 'book_article')
		{
			$this->baseArray['order']['title'] = FALSE;
			$this->baseArray['pre']['title'] = "'";
			$this->baseArray['post']['title'] = "'";
		}
		else if(($this->type == 'journal_article') || ($this->type == 'web_article'))
		{
			$this->baseArray['order']['title'] = FALSE;
			if($this->type == 'journal_article')
				$this->baseArray['pre']['page_start'] = "";
			else
			{
				$this->baseArray['pre']['page_start'] = "(";
				$this->baseArray['post']['page_end'] = ")";
			}
			$this->baseArray['pre']['year'] = "(";
			$this->baseArray['pre']['title'] = "'";
			$this->baseArray['post']['title'] = "'";
		}
		if((($this->type == 'book') || ($this->type == 'book_article')) && $reprint)
			$this->baseArray['post']['year'] = '; ';
// If publisher_location is missing and publisher details are to be printed (using 'missing' above), 
// what is post-punctuation?
		if(!$pubLoc)
			$this->baseArray['post']['publisher_location'] = ",";
// What string to print pre- or post- editorString?
// to print after (if $noAuthor is TRUE) editorString if more than one editor
		if($noAuthor)
		{
			$this->baseArray['pre']['editor'] = "";
			$this->stringPunc['editor'] = "";
			if($multipleEditors)
				$this->baseArray['post']['editor'] = ", eds";
			else if(!$multipleEditors)
				$this->baseArray['post']['editor'] = ", ed.";
		}
// OTHER VARIABLES
// Delimiter for name initials
		$this->initialsDelimiter = ". ";
// List delimiter (for lists of 3 or more names (potentially with 'et_al' etc).
		$this->listDelimiter = ", ";
// Override $this->listDelimiter for ultimate position in list e.g. name1, name2, name3 & name4.
		$this->listDelimiterOverride = " &";
// Maximum no. writers allowed for 'author', 'editor' etc. before 'et_al' is used
		$this->maxWritersLimit = 3;
// If maxWritersLimit is exceeded, how many writers to display before using 'et_al'?
		$this->maxWriters = 1;
// et al for authors and editors - what is printed if set?
		$this->et_al = " and others";
		$this->ed_et_al = " and others";
		$this->trans_et_al = " and others";
		$this->rev_et_al = " and others";
// what punctuation comes after all initials have been printed?
		$this->postInitials = ".";
// if date_accessed for web articles, format it (comes in as YYYY-MM-DD).
// mktime -> hour, minute, second, month, day, year
		if($date_accessed)
		{
			$array = explode('-', $date_accessed);
			$this->dateAccessed = date("d F Y", mktime(0, 0, 0, $array[1], $array[2], $array[0]));
		}
// ordinal text for cardinal numbers (used for edition which goes to maximum of 20)
		$this->ordinal = array(
						1	=>	'st ',
						2	=>	'nd ',
						3	=>	'rd ',
				);
		for($i = 4; $i <= 20; $i++)
			$this->ordinal[$i] = 'th ';
// What are volume numbers converted to? (up to 20)
		$this->volumeNumberConvert = array(
						1	=>	'I',
						2	=>	'II',
						3	=>	'III',
						4	=>	'IV',
						5	=>	'V',
						6	=>	'VI',
						7	=>	'VII',
						8	=>	'VIII',
						9	=>	'IX',
						10	=>	'X',
						11	=>	'XI',
						12	=>	'XII',
						13	=>	'XIII',
						14	=>	'XIV',
						15	=>	'XV',
						16	=>	'XVI',
						17	=>	'XVII',
						18	=>	'XVIII',
						19	=>	'XIX',
						20	=>	'XX',
				);
// Print values of baseArray for debugging purposes:
/*
foreach($this->baseArray as $key => $value)
{
	print "$key => $value";
	if(is_array($value))
	{
		print "()<BR>";
		foreach($value as $key2 => $value2)
			print "$key2 => $value2<BR>";
	}
	print "<BR>";
}
*/
	}
}
?>
